package myCBR;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import de.dfki.mycbr.core.DefaultCaseBase;
import de.dfki.mycbr.core.ICaseBase;
import de.dfki.mycbr.core.Project;
import de.dfki.mycbr.core.casebase.Attribute;
import de.dfki.mycbr.core.casebase.Instance;
import de.dfki.mycbr.core.casebase.MultipleAttribute;
import de.dfki.mycbr.core.model.AttributeDesc;
import de.dfki.mycbr.core.model.BooleanDesc;
import de.dfki.mycbr.core.model.Concept;
import de.dfki.mycbr.core.model.ConceptDesc;
import de.dfki.mycbr.core.model.FloatDesc;
import de.dfki.mycbr.core.model.StringDesc;
import de.dfki.mycbr.core.model.SymbolDesc;
import de.dfki.mycbr.core.retrieval.Retrieval;
import de.dfki.mycbr.core.retrieval.Retrieval.RetrievalMethod;
import de.dfki.mycbr.core.similarity.AdvancedFloatFct;
import de.dfki.mycbr.core.similarity.FloatFct;
import de.dfki.mycbr.core.similarity.Similarity;
import de.dfki.mycbr.core.similarity.SymbolFct;
import de.dfki.mycbr.core.similarity.config.MultipleConfig.Type;


public class MyCBRTest {

	public static void main (String[] args) {
		
		try {
			
			File file = new File("ArmyModel\\ArmyModel.prj");
			
			Project j = new Project(file.getAbsolutePath()); 
			while(j.isImporting()){}
			System.out.println(j.getCaseBases());
			DefaultCaseBase cb2 = (DefaultCaseBase) j.getCaseBases().get("Army");
			
			
			
			
			Concept army = j.getConceptByID("Army");
//			Concept armyList = j.getConceptByID("ArmyList");
			Concept unit = j.getConceptByID("Unit");
			Concept profile = j.getConceptByID("Profile");
			
//			Concept testList = j.getConceptByID("testList");
			
//			System.out.println(profile.);
			
//			System.out.println("case:" + cb2.getCases());
			System.out.println(". " + j.getCB("Army").getCases());
			
			
//			Instance i = army.addInstance("woot");
//			Instance list1 = armyList.addInstance("wootList");
//			Instance unitInstance = unit.addInstance("wootUnit");
			
//			cb2.addCase(i);
//			System.out.println(j.getAllInstances());
//			for (Instance instance : j.getAllInstances()) {
//				if(instance.getName().equals("woot")){
////					cb2.addCase(instance);
//					System.out.println(cb2.getCases());
//					try {
//						j.removeInstance(instance.getName());			
//					} catch (Exception e) {
//						// TODO: handle exception
//						System.out.println("cant remove wtf");
//					}
//				}
//			}
			
			
			
			List<Instance> unitList = new ArrayList<Instance>();
			
			for (Instance instance : j.getAllInstances()) {
				if(instance.getConcept() == unit){
					System.out.println(instance);
					unitList.add(instance);
					
				}
			}
			
			System.out.println(unitList.size());
			
			
//			Instance testListInstance = testList.addInstance("wooterinoTesterino");
			
			
//			System.out.println(testListInstance.getAttributes());
			
			
//			/**
//			 * 
//			 */
			
//			HashMap<String, AttributeDesc> valueMapTest = testList.getAllAttributeDescs();
//			for (Map.Entry<String, AttributeDesc> entry : valueMapTest.entrySet()) {
//				System.out.println(entry.getValue());
//				AttributeDesc desc = entry.getValue();
//				String attclass = desc.getClass().toString();
//				
//				if(attclass.compareTo("class de.dfki.mycbr.core.model.SymbolDesc")==0){
//					SymbolDesc sDesc = (SymbolDesc) entry.getValue();
//					Set<String> elements = sDesc.getAllowedValues();
//					
//					for (String string : elements) {
//						System.err.println(" " +string);
//					}
//					testListInstance.addAttribute(sDesc,elements.iterator().next());
//				}
//				else if(attclass.compareTo("class de.dfki.mycbr.core.model.ConceptDesc")==0){
//					ConceptDesc cDesc = (ConceptDesc) entry.getValue();
//					
//					if(cDesc.isMultiple()){
//						MultipleAttribute<ConceptDesc> mac= new MultipleAttribute<>(cDesc, new LinkedList<Attribute>());
//						mac.addValue(profile.addInstance("ehhha"));
//						mac.addValue(profile.addInstance("hihihaha"));
//						boolean ret = testListInstance.addAttribute(cDesc,mac);
//						System.err.println(ret +" " + testListInstance.getAttributes());
//					}
//					else{
//						boolean ret = testListInstance.addAttribute(cDesc,profile.addInstance("newMeProfile"));
//						System.err.println(ret +" " + testListInstance.getAttributes());
//					}
//				}
//				else if(attclass.compareTo("class de.dfki.mycbr.core.model.StringDesc")==0){
//					StringDesc strDesc = (StringDesc) entry.getValue();
//					String s = strDesc.getName();
//					System.err.println(" "+s);
//					testListInstance.addAttribute(strDesc,"ll");
//				}
//				else if(attclass.compareTo("class de.dfki.mycbr.core.model.FloatDesc")==0){
//					FloatDesc fDesc = (FloatDesc) entry.getValue();
//					Float frMin = fDesc.getMin();
//					Float frMax = fDesc.getMax();
//					System.err.println(" " +frMin + " " + frMax);
//					testListInstance.addAttribute(fDesc,  Math.random()*5000);
//				}
//			}
//			
//			
//			System.out.println(testListInstance.getAttributes());
			
			
			
			
			/**
			 * 
			 */
			
			
//			System.out.println(i.getAttributes());
//			HashMap<String, AttributeDesc> valueMap = army.getAllAttributeDescs(); 
//			for (Map.Entry<String, AttributeDesc> entry : valueMap.entrySet()) {
//				System.out.println(entry.getValue());
//				AttributeDesc desc = entry.getValue();
//				String attclass = desc.getClass().toString();
//				
//				if(attclass.compareTo("class de.dfki.mycbr.core.model.SymbolDesc")==0){
//					SymbolDesc sDesc = (SymbolDesc) entry.getValue();
//					Set<String> elements = sDesc.getAllowedValues();
//					
//					for (String string : elements) {
//						System.err.println(" " +string);
//					}
//					i.addAttribute(sDesc,elements.iterator().next());
//				}
//				else if(attclass.compareTo("class de.dfki.mycbr.core.model.ConceptDesc")==0){
//					ConceptDesc cDesc = (ConceptDesc) entry.getValue();
//					Concept c = cDesc.getConcept();
//					System.err.println(" " +c.getName() + " " + cDesc);
////					i.addAttribute(cDesc,list1); //TODO
//				}
//				else if(attclass.compareTo("class de.dfki.mycbr.core.model.StringDesc")==0){
//					StringDesc strDesc = (StringDesc) entry.getValue();
//					String s = strDesc.getName();
//					System.err.println(" "+s);
//					i.addAttribute(strDesc,"ll");
//				}
//				else if(attclass.compareTo("class de.dfki.mycbr.core.model.FloatDesc")==0){
//					FloatDesc fDesc = (FloatDesc) entry.getValue();
//					Float frMin = fDesc.getMin();
//					Float frMax = fDesc.getMax();
//					System.err.println(" " +frMin + " " + frMax);
//					i.addAttribute(fDesc,  Math.random()*5000);
//				}
//			}
			
//			System.out.println(i.getAttributes());
//			System.out.println(i.hasChanged());
//			
//			FloatAttribute fa = (FloatAttribute)(i.getAttributes().values().toArray()[0]);
//			
//			System.err.println(fa.getValue());
//			
////			System.out.println(list1.getAttributes());
//			
//			System.out.println(unitInstance.getAttributes());
			
//			int index = 0;
			
//			HashMap<String, AttributeDesc> valueUnit = armyList.getAllAttributeDescs(); 
//			for (Map.Entry<String, AttributeDesc> entry : valueUnit.entrySet()) {
//				System.out.println(entry.getValue());
//				AttributeDesc desc = entry.getValue();
//				String attclass = desc.getClass().toString();
//				
//				if(attclass.compareTo("class de.dfki.mycbr.core.model.SymbolDesc")==0){
//					SymbolDesc sDesc = (SymbolDesc) entry.getValue();
//					Set<String> elements = sDesc.getAllowedValues();
//					
//					for (String string : elements) {
//						System.err.println(" " +string);
//					}
//				}
//				else if(attclass.compareTo("class de.dfki.mycbr.core.model.ConceptDesc")==0){
//					ConceptDesc cDesc = (ConceptDesc) entry.getValue();
//					Concept c = cDesc.getConcept();
//					System.err.println(" " +cDesc + " " +c.getName());
////					Instance tempUnit = unit.addInstance("temp" + index);
////					index+=1;
//					boolean ret2 = list1.addAttribute(cDesc.getName(), unitInstance);
//					boolean ret = list1.addAttribute(cDesc, unitInstance);
//					System.out.println(ret + " " + ret2 + "" + list1.getAttributes());
//				}
//				else if(attclass.compareTo("class de.dfki.mycbr.core.model.StringDesc")==0){
//					StringDesc strDesc = (StringDesc) entry.getValue();
//					String s = strDesc.getName();
//					System.err.println(" "+s);
//				}
//				else if(attclass.compareTo("class de.dfki.mycbr.core.model.FloatDesc")==0){
//					FloatDesc fDesc = (FloatDesc) entry.getValue();
//					Float frMin = fDesc.getMin();
//					Float frMax = fDesc.getMax();
//					System.err.println(" " +frMin + " " + frMax);
//				}
//			}
//			
//			System.out.println(list1.getAttributes());
//			
//			System.out.println(unitInstance.getAttributes());
			
			
			System.out.println(unit.getAllInstances());
			
			
			
			
			
			
			
			Retrieval r2 = new Retrieval(army,cb2);
			Instance q2 = r2.getQueryInstance();
			
//			System.out.println(army.getAttributeDescs());
			SymbolDesc a = (SymbolDesc) army.getAttributeDesc("Faction");
			FloatDesc f = (FloatDesc) army.getAttributeDesc("TotalPoints");
			ConceptDesc u = (ConceptDesc) army.getAttributeDesc("Units");
//			
			if(u.isMultiple()){
				MultipleAttribute<ConceptDesc> ma = new MultipleAttribute<ConceptDesc>(u, new LinkedList<Attribute>());
				System.out.println(unitList.get(0).getAttributes());
//				ma.addValue(unitList.get((int) (Math.random()*unitList.size())));
				q2.addAttribute(u, ma);
//				ma.addValue(unitList.get(1));
//				ma.addValue(unitList.get(3));
				ma.addValue(unitList.get(43));
				ma.addValue(unitList.get(2));
			}
			
//			ConceptDesc l = (ConceptDesc) army.getAttributeDesc("List");
			
			
//			Concept armyList = j.getConceptByID("ArmyList");
			
//			System.out.println("something*: " + armyList.getAllInstances());
			
//			System.out.println("armylist: " +l.getConcept().getInstance("ArmyList #0").getAttributes().values());
//			System.out.println(army.getAttributeDescs());
			
			System.out.println(army.getAllAttributeDescs());
			
//			System.out.println("." + j.getCB("Army").getCases());
			
//			System.out.println(armyList.getAttributeDescs());
			
			
			q2.addAttribute(a.getName(), a.getAttribute("Dwarfs"));
			q2.addAttribute(f, f.getNumberAttribute(2400));
//			q2.addAttribute(l, l.getConcept().getInstance("ArmyList #0"));
			System.out.println(q2.getAttributes());
			
			System.out.println();
			System.out.println("multiUnit stuff:");
			
			u.getMultipleConfig(army.getActiveAmalgamFct()).setType(Type.AVG);
			System.out.println(u.getMultipleConfig(army.getActiveAmalgamFct()).getType());
			System.out.println(u.getMultipleConfig(army.getActiveAmalgamFct()).getMainType());
			System.out.println(u.getMultipleConfig(army.getActiveAmalgamFct()).getReuse());
			
			System.out.println();
			System.out.println("army stuff:");
			
			System.out.println(army.getActiveAmalgamFct().getType());
			System.out.println("fact: " +army.getActiveAmalgamFct().getWeight(a));
			System.out.println("point: " +army.getActiveAmalgamFct().getWeight(f));
			System.out.println("units: " +army.getActiveAmalgamFct().getWeight(u));
			
//			army.getActiveAmalgamFct().setWeight(u, 0);
			
			System.out.println();
			System.out.println("unit stuff:");
			System.out.println(unit.getActiveAmalgamFct().getType());
			
			SymbolDesc armyType = (SymbolDesc) unit.getAttributeDesc("ArmyType");
			
			System.out.print("armytype: "+ unit.getActiveAmalgamFct().getWeight(armyType) + " " + unit.getActiveAmalgamFct().isActive(armyType));
			
			SymbolFct armyTypeSfct = (SymbolFct) unit.getActiveAmalgamFct().getActiveFct(armyType);
			
			System.out.print(", " +armyTypeSfct.getName() + "\n");
			
			Set<String> allowedArmyTypes = armyType.getAllowedValues();
			
			
//			System.out.println(armyTypeSfct.setSimilarity("Hero", "Lord", 0.8)); //import not working tyvm blizz...
			System.out.println(armyTypeSfct.calculateSimilarity("Hero", "Lord"));
			
			for (String fct : allowedArmyTypes) {
				System.out.print(fct + " , " );
				Attribute current = armyType.getAttribute(fct);
				for (String innerFct : allowedArmyTypes) {
					System.out.print(innerFct + ": " +armyTypeSfct.calculateSimilarity(current, armyType.getAttribute(innerFct)) + " ");
					
				}
				System.out.print("\n");
			}
			
			BooleanDesc magician = (BooleanDesc) unit.getAttributeDesc("Magician");
			ConceptDesc equipment = (ConceptDesc) unit.getAttributeDesc("Equipment");
			StringDesc name = (StringDesc) unit.getAttributeDesc("Name");
			FloatDesc points = (FloatDesc) unit.getAttributeDesc("Point");
			BooleanDesc ranged = (BooleanDesc) unit.getAttributeDesc("Ranged");
			ConceptDesc unitprofile = (ConceptDesc) unit.getAttributeDesc("UnitProfile");

			
			System.out.println("magician: " + unit.getActiveAmalgamFct().getWeight(magician) + " " + unit.getActiveAmalgamFct().isActive(magician));
			System.out.println("equipment: " + unit.getActiveAmalgamFct().getWeight(equipment) + " " + unit.getActiveAmalgamFct().isActive(equipment));
			System.out.println("Name: " + unit.getActiveAmalgamFct().getWeight(name) + " " + unit.getActiveAmalgamFct().isActive(name));
			System.out.println("Points: " + unit.getActiveAmalgamFct().getWeight(points) + " " + unit.getActiveAmalgamFct().isActive(points));
			System.out.println("ranged: " + unit.getActiveAmalgamFct().getWeight(ranged) + " " + unit.getActiveAmalgamFct().isActive(ranged));
			System.out.println("unitProfile: " + unit.getActiveAmalgamFct().getWeight(unitprofile) + " " + unit.getActiveAmalgamFct().isActive(unitprofile));
			
			
			
			
			System.out.println();
			System.out.println("profile stuff:");
			System.out.println(profile.getActiveAmalgamFct().getType());
			
			FloatDesc A = (FloatDesc) profile.getAttributeDesc("A");
			FloatDesc I = (FloatDesc) profile.getAttributeDesc("I");
			SymbolDesc unitType = (SymbolDesc) profile.getAttributeDesc("UnitType");
			
			System.out.println("A: " + profile.getActiveAmalgamFct().getWeight(A) + " " + profile.getActiveAmalgamFct().isActive(A) + ", "+ ((FloatFct) profile.getActiveAmalgamFct().getActiveFct(A)).getName());
			System.out.println("I: " + profile.getActiveAmalgamFct().getWeight(I) + " " + profile.getActiveAmalgamFct().isActive(I) + ", "+ ((FloatFct) profile.getActiveAmalgamFct().getActiveFct(I)).getName());
			System.out.println("unitType: " + profile.getActiveAmalgamFct().getWeight(unitType) + " " + profile.getActiveAmalgamFct().isActive(unitType)+ ", "+ ((SymbolFct) profile.getActiveAmalgamFct().getActiveFct(unitType)).getName());
			
			SymbolFct armyUnitTypeFct = (SymbolFct) profile.getActiveAmalgamFct().getActiveFct(unitType);
			
			Set<String> allowedUnitTypes = unitType.getAllowedValues();
			for (String allowedUpper : allowedUnitTypes) {
				Attribute current = unitType.getAttribute(allowedUpper);
				for (String allowedInner : allowedUnitTypes) {
					System.out.print(allowedInner + ": " + armyUnitTypeFct.calculateSimilarity(current, unitType.getAttribute(allowedInner)) + ", ");
				}
				System.out.print(" : "+ allowedUpper );
				System.out.print("\n");
			}
			
			
			System.out.println();
			
			
			
			
//			unit.getActiveAmalgamFct().setWeight(ranged, 2);
			
//			Instance unitInstance = unit.getInstance("Unit #0");
//			System.out.println(unitInstance.addAttribute(ranged, true));
//			System.out.println(unitInstance.getAttributes());
			
			
//			for (AttributeDesc aDesc : unit.getAllAttributeDescs().values()) {
//				try {
//					if(aDesc.getAttribute(ranged)!=null){
//						System.out.println(aDesc + " " +aDesc.getAttribute(ranged));
////						Retrieval r3 = new Retrieval(unit,cb2);
////						Instance q3 = r3.getQueryInstance();
////						q3.addAttribute(ranged, true);
////						System.out.println(q3.getAttributes());
////						r3.start();
////						System.out.println(r3);
////						unit.
//					}
//				} catch (Exception e) {
//					System.err.println(e.getStackTrace());
//				}
//				
//			}
			
//			System.out.println();
//			System.out.println(ranged.getAllowedValues());
//			
//			SymbolFct rangedSfct = (SymbolFct) unit.getActiveAmalgamFct().getActiveFct(ranged);
//			
//			Set<String> allowedRanged = ranged.getAllowedValues();
//			
//			System.out.println(allowedRanged.size());
//			
//			for (String string : allowedRanged) {
//				System.out.println(string);
//			}
			
			
			
			r2.setRetrievalMethod(RetrievalMethod.RETRIEVE_SORTED);
			System.out.println(q2.getAttributes());
//			System.out.println(r2.getRetrievalEngine().retrieveSorted(cb2, q2));
			r2.start();
			System.out.println("result:"+r2);
			print(r2);
			
			System.out.println();
			
			
			
			/*
			Retrieval r3 = new Retrieval(army,cb2);
			r3.setRetrievalMethod(RetrievalMethod.RETRIEVE_SORTED);
			Instance q3 = r3.getQueryInstance();
			q3.setAttsUnknown();
			
			
			//InitValues for no specifications in the query.
			
			q3.addAttribute(a, j.NO_SPECIAL_VALUE);
			q3.addAttribute(f, j.NO_SPECIAL_VALUE);
			q3.addAttribute(u, j.NO_SPECIAL_VALUE);
			
			
			q3.addAttribute(a, a.getAttribute("Dwarfs")); 
//			q3.addAttribute(f, f.getAttribute(2400));
			
			MultipleAttribute<ConceptDesc> ma3 = new MultipleAttribute<ConceptDesc>(u, new LinkedList<>());
			
			Instance randomUnit = unit.addInstance("FluffyUnit");
			
			Instance randomProfile = profile.addInstance("FluffyProfile");
			
			randomProfile.addAttribute(A, A.getAttribute(3));
			randomProfile.addAttribute(I, I.getAttribute(5));
			randomProfile.addAttribute(unitType, unitType.getAttribute("Infantry"));
			System.out.println("profile: " +randomProfile.getAttributes());
			
			randomUnit.addAttribute(unitprofile, randomProfile);
			randomUnit.addAttribute(points, points.getAttribute(150));
			randomUnit.addAttribute(armyType,armyType.getAttribute("Special"));
			System.out.println("unit: " +randomUnit.getAttributes());
			
			ma3.addValue(randomUnit);
			
			q3.addAttribute(u, ma3);
			System.out.println("query "+ q3.getAttributes());
			r3.start();
			System.out.println(r3);
			print(r3);
			
			System.out.println(j.getAllInstances());
			
			
			
			
			
			
			
			UnitInstance uc = new UnitInstance(j);
			uc.createUnit(unit, "test123");
			uc.initEmptyUnit();
			
			
			ICaseBase cbUnit = j.getCaseBases().get("Units");
			
			for (Instance i : cbUnit.getCases()) {
//				System.out.print(i.getAttributes());
				i.addAttribute("Magician", true);
				i.addAttribute("Ranged", true);
//				System.out.print(" " + i.getAttributes() +"\n");
			}
			
			
			
			
			Retrieval r4Unit = new Retrieval(unit,cbUnit);
			Instance q4 = r4Unit.getQueryInstance();
			
			System.out.println(q4.getAttributes());
			
			UnitInstance q4u = new UnitInstance(j);
			
			q4u.usePreviousUnit(unit, q4);
			q4u.initEmptyUnit();
						
			System.out.println(q4.getAttributes());
			
			r4Unit.run();
			
			System.out.println(r4Unit);
			
			
			j.createDefaultCB("lel");
			
			ICaseBase lel = j.getCB("lel");
			
			
			
			System.out.println(j.getAllInstances().size());
			System.out.println(j.getAllInstances());
			System.out.println(j.getTotalNumberOfCases());
			System.out.println(j.getCaseBases());
			System.out.println(lel.getProject());
			
			
			*/
			
			
			
			/**
			 * profile+unit generator test
			 * 
			 */
			/*
			ProfileInstance someProfile = new ProfileInstance(j);
			someProfile.createProfile(profile, "peggyProfile");

			Instance peggyProfile = someProfile.getProfileInstance();
			
			System.out.println(peggyProfile.getAttributes());
			
			someProfile.setMR(2);
			someProfile.setWS(10);
			someProfile.setI(9);
			someProfile.setW(8);
			someProfile.setLd(7);
			someProfile.setT(6);
			someProfile.setArmorSave(0);
			someProfile.setM(5);
			someProfile.setS(4);
			someProfile.setA(3);
			someProfile.setBS(2);
			someProfile.setName("PeggyProfile");
			someProfile.setWardSave(0);
			someProfile.setUnitType("Swarm");
			
			for (AttributeDesc desc : peggyProfile.getAttributes().keySet()) {
				System.out.println(desc + " " +  peggyProfile.getAttForDesc(desc).getValueAsString());
			}
			
			System.err.println(someProfile.getMR());
			System.err.println(someProfile.getWS());
			System.err.println(someProfile.getI());
			System.err.println(someProfile.getW());
			System.err.println(someProfile.getLd());
			System.err.println(someProfile.getT());
			System.err.println(someProfile.getArmorSave());
			System.err.println(someProfile.getM());
			System.err.println(someProfile.getS());
			System.err.println(someProfile.getA());
			System.err.println(someProfile.getBS());
			System.err.println(someProfile.getName());
			System.err.println(someProfile.getWardSave());
			System.err.println(someProfile.getUnitType());
			
			
			UnitInstance someUnit = new UnitInstance(j);
			someUnit.createUnit(unit, "peggy");
			
			Instance peggy = someUnit.getUnitInstance();
			System.out.println(peggy.getAttributes());
			
			someUnit.setName("peggy");
			someUnit.setArmyType("Core");
			someUnit.setProfile(peggyProfile);
			someUnit.setMagician(false);
			someUnit.setRanged(true);
			someUnit.setPoints(160);
			someUnit.setModelCount(10);

			System.out.println(peggy.getAttributes());
			
			
			
			UnitInstance someUnitCopy = new UnitInstance(j);
			someUnitCopy.copyFromPreviousUnit(unit, peggy, "peggy2");
			
			System.out.println(someUnitCopy.getUnitInstance() + " "+ someUnitCopy.getUnitInstance().getAttributes());
			System.out.println(someUnitCopy.getUnitInstance() == peggy);
			
			someUnit.createUnit(unit, "new peggy");
			
			System.out.println(peggy + ": " + someUnit.getUnitInstance());
			System.out.println(peggy.getAttributes() + "\n" + someUnit.getUnitInstance().getAttributes());
			
			System.out.println(j.getAllInstances());
			
			
			
			ArmyInstance someArmy = new ArmyInstance(j);
			
			someArmy.createArmy(army, "peggieswarriors");
			
			System.out.println(someArmy.getArmyInstance() + " " +someArmy.getArmyInstance().getAttributes());
			
			someArmy.addUnitToMultiUnit(peggy);
			
			System.out.println(someArmy.getArmyInstance() + " " +someArmy.getArmyInstance().getAttributes());
			
			ArmyInstance someArmyCopy = new ArmyInstance(j);
			
			someArmyCopy.copyArmyInstance(army, someArmy.getArmyInstance(), "lel");
			
			System.out.println(someArmyCopy.getArmyInstance().getAttributes());
			
			
			someArmyCopy.addUnitToMultiUnit(someUnit.getUnitInstance());
			
			System.out.println(someArmyCopy.getArmyInstance().getAttributes());
			*/
//			cb2.removeCase(i);
//			j.save();
//			*/
		} catch (Exception e) {
			System.err.println("shit went wrong dawg");
			e.printStackTrace();
		}
		
	}

	private static void print(Retrieval r) {
		for (Map.Entry<Instance, Similarity> entry: r.entrySet()) {
			if(entry.getValue().getValue()>0.0)
			System.out.println("\nSimilarity: " + entry.getValue().getValue()
					+ " to case: " + entry.getKey().getName());
		}
	}
	
	
}

