package myCBR;

import java.text.ParseException;

import de.dfki.mycbr.core.Project;
import de.dfki.mycbr.core.casebase.Instance;
import de.dfki.mycbr.core.model.BooleanDesc;
import de.dfki.mycbr.core.model.Concept;
import de.dfki.mycbr.core.model.ConceptDesc;
import de.dfki.mycbr.core.model.FloatDesc;
import de.dfki.mycbr.core.model.IntegerDesc;
import de.dfki.mycbr.core.model.StringDesc;
import de.dfki.mycbr.core.model.SymbolDesc;

public class ProfileInstance {
	private Instance thisProfileInstance;
	private Concept profile;
	private Project prj;
	
	public ProfileInstance(Project j){
		prj = j;
	}
	
	public void createProfile(Concept profile, String name) {
		try {
			thisProfileInstance = profile.addInstance(name);
			this.profile = profile;
			initEmptyUnit();
		} catch (Exception e) {
			System.err.println("Something went wrong with unit creation");
			e.printStackTrace();
		}
	}
	
	public void initEmptyUnit(){
		EmptyInstance ei = new EmptyInstance();
		ei.reset(thisProfileInstance, prj);
	}
	
	public void setUnitType(String category){
		SymbolDesc unitType = (SymbolDesc) profile.getAttributeDesc("UnitType");
		thisProfileInstance.addAttribute(unitType, unitType.getAttribute(category));
	}
	
	public String getUnitType(){
		SymbolDesc unitType = (SymbolDesc) profile.getAttributeDesc("UnitType");
		return thisProfileInstance.getAttForDesc(unitType).getValueAsString();
	}
	
	
	public void setMR(float value){
		FloatDesc profileMR = (FloatDesc) profile.getAttributeDesc("MR");
		try {
			thisProfileInstance.addAttribute(profileMR, profileMR.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for MR");
			e.printStackTrace();
		}
	}
	
	public float getMR(){
		FloatDesc profileMR = (FloatDesc) profile.getAttributeDesc("MR");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileMR).getValueAsString());
	}
	
	public void setWS(float value){
		FloatDesc profileWS = (FloatDesc) profile.getAttributeDesc("WS");
		try {
			thisProfileInstance.addAttribute(profileWS, profileWS.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for WS");
			e.printStackTrace();
		}
	}
	
	public float getWS(){
		FloatDesc profileWS = (FloatDesc) profile.getAttributeDesc("WS");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileWS).getValueAsString());
	}
	
	public void setI(float value){
		FloatDesc profileI = (FloatDesc) profile.getAttributeDesc("I");
		try {
			thisProfileInstance.addAttribute(profileI, profileI.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for I");
			e.printStackTrace();
		}
	}
	
	public float getI(){
		FloatDesc profileI = (FloatDesc) profile.getAttributeDesc("I");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileI).getValueAsString());
	}
	
	public void setW(float value){
		FloatDesc profileW = (FloatDesc) profile.getAttributeDesc("W");
		try {
			thisProfileInstance.addAttribute(profileW, profileW.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for W");
			e.printStackTrace();
		}
	}
	
	public float getW(){
		FloatDesc profileW = (FloatDesc) profile.getAttributeDesc("W");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileW).getValueAsString());
	}
	
	public void setLd(float value){
		FloatDesc profileLd = (FloatDesc) profile.getAttributeDesc("Ld");
		try {
			thisProfileInstance.addAttribute(profileLd, profileLd.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for Ld");
			e.printStackTrace();
		}
	}
	
	public float getLd(){
		FloatDesc profileLd = (FloatDesc) profile.getAttributeDesc("Ld");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileLd).getValueAsString());
	}
	
	public void setT(float value){
		FloatDesc profileT = (FloatDesc) profile.getAttributeDesc("T");
		try {
			thisProfileInstance.addAttribute(profileT, profileT.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for T");
			e.printStackTrace();
		}
	}
	
	public float getT(){
		FloatDesc profileT = (FloatDesc) profile.getAttributeDesc("T");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileT).getValueAsString());
	}
	
	public void setM(float value){
		FloatDesc profileM = (FloatDesc) profile.getAttributeDesc("M");
		try {
			thisProfileInstance.addAttribute(profileM, profileM.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for M");
			e.printStackTrace();
		}
	}
	
	public float getM(){
		FloatDesc profileM = (FloatDesc) profile.getAttributeDesc("M");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileM).getValueAsString());
	}
	
	public void setS(float value){
		FloatDesc profileS = (FloatDesc) profile.getAttributeDesc("S");
		try {
			thisProfileInstance.addAttribute(profileS, profileS.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for S");
			e.printStackTrace();
		}
	}
	
	public float getS(){
		FloatDesc profileS = (FloatDesc) profile.getAttributeDesc("S");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileS).getValueAsString());
	}
	
	public void setA(float value){
		FloatDesc profileA = (FloatDesc) profile.getAttributeDesc("A");
		try {
			thisProfileInstance.addAttribute(profileA, profileA.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for A");
			e.printStackTrace();
		}
	}
	
	public float getA(){
		FloatDesc profileA = (FloatDesc) profile.getAttributeDesc("A");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileA).getValueAsString());
	}
	
	public void setBS(float value){
		FloatDesc profileBS = (FloatDesc) profile.getAttributeDesc("BS");
		try {
			thisProfileInstance.addAttribute(profileBS, profileBS.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for BS");
			e.printStackTrace();
		}
	}
	
	public float getBS(){
		FloatDesc profileBS = (FloatDesc) profile.getAttributeDesc("BS");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileBS).getValueAsString());
	}
	
	public void setArmorSave(float value){
		FloatDesc profileArmorSave = (FloatDesc) profile.getAttributeDesc("ArmorSave");
		try {
			thisProfileInstance.addAttribute(profileArmorSave, profileArmorSave.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for armorSave");
			e.printStackTrace();
		}
	}
	
	public float getArmorSave(){
		FloatDesc profileArmorSave = (FloatDesc) profile.getAttributeDesc("ArmorSave");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileArmorSave).getValueAsString());
	}
	
	public void setWardSave(float value){
		FloatDesc profileWardSave = (FloatDesc) profile.getAttributeDesc("WardSave");
		try {
			thisProfileInstance.addAttribute(profileWardSave, profileWardSave.getAttribute(value));
		} catch (ParseException e) {
			System.err.println("could not set float value for armorSave");
			e.printStackTrace();
		}
	}
	
	public float getWardSave(){
		FloatDesc profileWardSave = (FloatDesc) profile.getAttributeDesc("WardSave");
		return Float.parseFloat(thisProfileInstance.getAttForDesc(profileWardSave).getValueAsString());
	}
	
	public void setName(String name){
		StringDesc profileName = (StringDesc) profile.getAttributeDesc("Name");
		try {
			thisProfileInstance.addAttribute(profileName, name);
		} catch (ParseException e) {
			System.err.println("could not set string for name");
			e.printStackTrace();
		}
	}
	
	public String getName(){
		StringDesc profileName = (StringDesc) profile.getAttributeDesc("Name");
		return thisProfileInstance.getAttForDesc(profileName).getValueAsString();
	}
	
//	public boolean getIdentical(ProfileInstance comparedInstance){
//		boolean ret = false;
//		if( (comparedInstance.getA()==getA())
//			&& 	(comparedInstance.getM()==getM())
//			&& 	(comparedInstance.getMR()==getMR())
//			&& 	(comparedInstance.getWS()==getWS())
//			&& 	(comparedInstance.getLd()==getLd())
//			&& 	(comparedInstance.getBS()==getBS())
//			&& 	(comparedInstance.getS()==getS())
//			&& 	(comparedInstance.getI()==getI())
//			&& 	(comparedInstance.getT()==getT())
//			&& 	(comparedInstance.getW()==getW())
//			&& 	(comparedInstance.getUnitType()==getUnitType())
//			&& 	(comparedInstance.getWardSave()==getWardSave())
//			&& 	(comparedInstance.getArmorSave()==getArmorSave())
//			&& 	(comparedInstance.getName()==getName())
//			)
//			ret= true;
//		return ret;
//	}
	
	public Instance getProfileInstance(){
		return thisProfileInstance;
	}
	
	
}
