package myCBR;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;


import parserXML.OverviewSpecifics;
import de.dfki.mycbr.core.DefaultCaseBase;
import de.dfki.mycbr.core.Project;
import de.dfki.mycbr.core.casebase.Instance;
import de.dfki.mycbr.core.model.Concept;
import de.dfki.mycbr.core.retrieval.Retrieval;
import de.dfki.mycbr.core.similarity.Similarity;
import de.dfki.mycbr.util.Pair;

public class RetriveArmies {
	
	private Project prj;
	private Concept army;
	private Concept unit;
	private DefaultCaseBase armyCaseBase;
	private OverviewSpecifics os;
	
	private String desiredFaction;
	private float desiredPointLimit;
	
	private float minimumCostOfUnit;
	public float lowestHeroLordCost;
		
	private List<UnitInstance> desiredUnits;
	
	private ArmyInstance queryResult;
	private Similarity querySimilarity;
	
	private HashMap<String, UnitInstance> availableFactionUnitInstances;
	
	public RetriveArmies(Project j, OverviewSpecifics os){
		this.prj = j;
		this.os = os;
		
		this.army = prj.getConceptByID("Army");
		this.armyCaseBase = (DefaultCaseBase) prj.getCB("Army");
		this.unit = prj.getConceptByID("Unit");
	}
	
	//TODO missing "don't care" options for faction and points. 
	
	public void getRetrivalInfo(){
		Scanner scan = new Scanner(System.in);
		int factionPos = -1;
		String [] factions = os.getAvailableFactions();
		System.err.println("This system is not dummy proof, use numbers where appropriate");
		System.out.println("When you are about to \"select\" something, type the number listed");
		System.out.println("For example \"0 Dwarfs\" means that you should type in 0 to choose Dwarfs");
		System.out.println("select faction");
		
		for (int i = 0; i < factions.length; i++) {
			System.out.println(i + " " + factions[i]);
		}
		while(factionPos<0){
			if(scan.hasNextInt())
				factionPos = scan.nextInt();
			else{
				System.err.println("You are doing it wrong. Choose a number in the range 0-"+(factions.length-1));
				scan.next();
			}
			if(factionPos>=factions.length){
				factionPos = -1;
				System.err.println("out of range");
			}
			else if(factionPos<0)
				System.err.println("out of range");
		}
		
		setDesiredFaction(factions[factionPos]);
		
		System.out.println("selected "  +desiredFaction);
		
		//TODO fix model to include ranges beyond 5000 points
		
		float points = -1;
		while(points<1000){
			System.out.println("specify point target (a number in the range 1000-5000)"); //, -2 for no limit"
			
			if(scan.hasNextFloat())
				points = scan.nextFloat();
			else{
				System.err.println("You are doing it wrong. Choose a number in the range 1000-5000");
				scan.next();
			}
			if(points>5000){
				points = -1;
				System.err.println("out of range");
			}
//			else if(points==-2){
//				break;
//				//TODO 
//			}
			else if(points<1000){
				System.err.println("too low number");
			}
			
		}
		
		setDesiredPointLimit(points);
		
		System.out.println("points " + desiredPointLimit);
		
		DefaultCaseBase factionUnits = (DefaultCaseBase) prj.getCB(os.getCorrectCB(desiredFaction));

		
		//Pick random or specify the units
//		boolean random = false;
//		
//		int rand = -1;
//		
//		System.out.println("Random units ?");
//		System.out.println("0 false");
//		System.out.println("1 false");
//		
//		while(rand<0){
//			rand = scan.nextInt();
//			
//			if(rand>=2){
//				rand = -1;
//				System.err.println("Either 0 (false) or 1 (true) ");
//			}
//		}
//		random = (rand==1?true:false);
		
		//TODO random units
		
		float pointsToSpend = desiredPointLimit;
		boolean stillMore = true;
		
		System.out.println("choose units among these");
		int index = 0;
		HashMap<String, Float> unitCost = new HashMap<>();
		HashMap<Integer, String> unitSelect = new HashMap<>();
		HashMap<String, Instance> availableUnits = new HashMap<>();
		HashMap<String, String> unitType = new HashMap<>();
		float minimumCost = pointsToSpend;
		float minimumCoreCost = pointsToSpend;
		float commandoCost = pointsToSpend;
		for (Instance instance: factionUnits.getCases()) {
			String name = instance.getName().split("_")[0];
			float count = Float.parseFloat(instance.getName().split("_")[1]);
			float cost = Float.parseFloat(instance.getName().split("_")[2])*count;
			String Type = instance.getName().split("_")[3];
			System.out.println(index + " " + name + " " + cost + " " + Type);
			
			if(minimumCost>cost)
				minimumCost = cost;
			if(Type.equals(os.getCore()) && minimumCoreCost>cost){
				minimumCoreCost = cost;
			}
			if((Type.equals(os.getHero())||Type.equals(os.getLord()) ) && commandoCost>cost){
				commandoCost = cost;
			}
			
			unitCost.put(name, cost);
			unitSelect.put(index , name);
			availableUnits.put(name, instance);
			unitType.put(name, Type);
			index++;
		}
		
		availableFactionUnitInstances = new HashMap<>();
		for (String string : availableUnits.keySet()) {
			UnitInstance availUnit = new UnitInstance(prj);
			availUnit.usePreviousUnit(unit, availableUnits.get(string));
//			System.out.println(availUnit.getUnitInstance() + " " + availUnit.getMinSelections() + " " + availUnit.getMaxInRoster());
			availUnit.initializeUnitValues();
			availableFactionUnitInstances.put(string, availUnit);
		}
		
		setLowestHeroLordCost(commandoCost);
		
		System.out.println(unitCost);
		System.out.println(unitSelect);
				
		List<String> addedUnits = new ArrayList<>();
		
		HashMap<String,Integer> allowedCount = new HashMap<>();
		
		float corePointsSpent = 0;
		float rarePointsSpent = 0;
		float specialPointsSpent = 0;
		float heroPointsSpent = 0;
		float lordPointsSpent = 0;
		
		
		while (pointsToSpend>0 && stillMore) {
			int input = -2;
			System.out.println("You can still include units with value "  + pointsToSpend + " or less");
			System.out.println("You can also stop by typing -1");
			
			if(scan.hasNextInt())
				input = scan.nextInt();
			else{
				System.err.println("numbers man!");
				scan.next();
				continue;
			}
			
			if(input == -1)
				stillMore = false;
			else if(input<-1){
				System.err.println("negative numbers lower than -1 wont work");
			}
			else if(input<unitSelect.size()){
				if(pointsToSpend>=unitCost.get(unitSelect.get(input))){
					if(!canAdd(corePointsSpent, rarePointsSpent, specialPointsSpent, heroPointsSpent, lordPointsSpent, unitCost.get(unitSelect.get(input)), unitType.get(unitSelect.get(input)), desiredPointLimit, unitSelect.get(input))){
						continue;
					}
					if(allowedCount.containsKey(unitSelect.get(input))){
						if(((allowedCount.get(unitSelect.get(input))+1)>availableFactionUnitInstances.get(unitSelect.get(input)).getMaxInRoster()) && (availableFactionUnitInstances.get(unitSelect.get(input)).getMaxInRoster()>-1)){
							System.err.println("Too many of " + unitSelect.get(input) + " max:" + availableFactionUnitInstances.get(unitSelect.get(input)).getMaxInRoster());
							continue;
						}
						allowedCount.put(unitSelect.get(input), allowedCount.get(unitSelect.get(input)) + 1);
					}
					else{
						allowedCount.put(unitSelect.get(input), 1);
					}
					System.out.println("Added " +unitSelect.get(input) + " " + unitCost.get(unitSelect.get(input)));
					pointsToSpend-=unitCost.get(unitSelect.get(input));
					
					if(unitType.get(unitSelect.get(input)).equals("Core")){
						corePointsSpent+=unitCost.get(unitSelect.get(input));
					}
					else if(unitType.get(unitSelect.get(input)).equals("Rare")){
						rarePointsSpent+=unitCost.get(unitSelect.get(input));
					}
					else if(unitType.get(unitSelect.get(input)).equals("Special")){
						specialPointsSpent+=unitCost.get(unitSelect.get(input));
					}
					else if(unitType.get(unitSelect.get(input)).equals("Hero")){
						heroPointsSpent+=unitCost.get(unitSelect.get(input));
					}
					else if(unitType.get(unitSelect.get(input)).equals("Lord")){
						lordPointsSpent+=unitCost.get(unitSelect.get(input));
					}
					
					addedUnits.add(unitSelect.get(input));
					System.out.println(allowedCount);
				}
				else
					System.err.println("unit costs too much");
			}
			else
				System.err.println("unit out of range");
			if(pointsToSpend<minimumCost || pointsToSpend<minimumCoreCost){
				System.out.println("impossible to add more units, exiting");
				stillMore = false;
			}
		}
		System.out.println("units in query " + addedUnits);
		
		desiredUnits = new ArrayList<>();
		for (String string : addedUnits) {
			UnitInstance addUnit = new UnitInstance(prj);
			addUnit.usePreviousUnit(unit, availableUnits.get(string));
			desiredUnits.add(addUnit);
		}
		for (UnitInstance ui : desiredUnits) {
			System.out.println(ui.getUnitInstance());
		}
		setMinimumCostOfUnit(minimumCost);
	}
	
	public void runQuery(){
		Retrieval retrieve = new Retrieval(army, armyCaseBase);
		Instance queryInstance = retrieve.getQueryInstance();
		
		ArmyInstance retrivalInstance = new ArmyInstance(prj);
		retrivalInstance.usePreviousArmy(army, queryInstance);
		retrivalInstance.initEmptyArmy();
		
		retrivalInstance.setFaction(desiredFaction);
		retrivalInstance.setTotalPoints(desiredPointLimit);
		
		
		retrivalInstance.initMultiUnit();
		for (UnitInstance unitInstance : desiredUnits) {
			retrivalInstance.addUnitToMultiUnit(unitInstance.getUnitInstance());
		}
		
		System.out.println(retrivalInstance.getArmyInstance().getAttributes());
		
		retrieve.run();
		
		System.out.println(retrieve.getResult());
		System.out.println();
		printResult(retrieve);
		
		Pair<Instance,Similarity> best = getBestResult(retrieve);
		
		System.out.println("Best " + best.getFirst() + " " + best.getSecond());
		ArmyInstance bestResult = new ArmyInstance(prj);
		bestResult.usePreviousArmy(army, best.getFirst());
		bestResult.initMultiUnitExisting();
		for (UnitInstance unitInstance : bestResult.getMultiUnitInstances()) {
			System.out.println(unitInstance.getUnitInstance());
		}
		System.out.println();
		
		setQueryResult(bestResult);
		setQuerySimilarity(best.getSecond());
	}
	
	public void printResult(Retrieval r){
		for (Map.Entry<Instance, Similarity> entry: r.entrySet()) {
			if(entry.getValue().getValue()>0.0){
				System.out.println("Similarity: " + entry.getValue().getValue()
						+ " to case: " + entry.getKey().getName());
				System.out.println(entry.getKey().getAttributes());
				System.out.println();
			}
		}
	}
	
	public Pair<Instance,Similarity> getBestResult(Retrieval r){
		Instance best = null;
		Similarity bestSim = null;
		for (Map.Entry<Instance, Similarity> entry: r.entrySet()) {
			if(entry.getValue().getValue()>0.0){
				if(best==null){
					best = entry.getKey();
					bestSim = entry.getValue();
				}
				else{
					if(bestSim.getValue()<entry.getValue().getValue()){
						best = entry.getKey();
						bestSim = entry.getValue();
					}
					else if(bestSim.getValue()==entry.getValue().getValue()){
						System.err.println("Two cases with identical similarity");
					}
				}
					
			}
		}
		Pair<Instance,Similarity> retPair = new Pair<Instance, Similarity>(best,bestSim);
		return retPair;
	}
	
	public boolean canAdd(float core, float rare, float special, float hero, float lord, float pointCostOfThis, String type, float totalPoint, String name){
		float combinedMinusCore = rare + special + hero + lord;
		
//		System.out.println(((rare+pointCostOfThis))>(os.getMaxRarePercentage()*totalPoint/100));
//		System.out.println(((rare+pointCostOfThis))+ " " + (os.getMaxRarePercentage()*totalPoint/100));
//				
		if(type.equals("Rare") && ((rare+pointCostOfThis))>(os.getMaxRarePercentage()*totalPoint/100)){
			System.err.println("Too many points spent on Rare. Can't add " +  name + " ("+pointCostOfThis+ ")>(" +((rare+pointCostOfThis)-(os.getMaxRarePercentage()*totalPoint/100)) +")");
			return false;
		}
		
//		System.out.println(((special+pointCostOfThis))>(os.getMaxSpecialPercentage()*totalPoint/100));
//		System.out.println(((special+pointCostOfThis))+ " " + (os.getMaxSpecialPercentage()*totalPoint/100));
		
		if(type.equals("Special") && ((special+pointCostOfThis))>(os.getMaxSpecialPercentage()*totalPoint/100)){
			System.err.println("Too many points spent on Special. Can't add " +  name+ " ("+pointCostOfThis+ ")>(" +((special+pointCostOfThis)-(os.getMaxSpecialPercentage()*totalPoint/100))+ ")");
			return false;
		}
		
//		System.out.println(((hero+pointCostOfThis))>(os.getMaxHeroesPercentage()*totalPoint/100));
//		System.out.println(((hero+pointCostOfThis))+ " " + (os.getMaxHeroesPercentage()*totalPoint/100));
		
		if(type.equals("Hero") && ((hero+pointCostOfThis))>(os.getMaxHeroesPercentage()*totalPoint/100)){
			System.err.println("Too many points spent on Hero. Can't add " +  name+ " ("+pointCostOfThis+ ")>(" +((hero+pointCostOfThis)-(os.getMaxHeroesPercentage()*totalPoint/100)) +")");
			return false;
		}
		
//		System.out.println(((lord+pointCostOfThis))>(os.getMaxLordsPercentage()*totalPoint/100));
//		System.out.println(((lord+pointCostOfThis))+ " " + (os.getMaxLordsPercentage()*totalPoint/100));
//		
		if(type.equals("Lord") && ((lord+pointCostOfThis))>(os.getMaxLordsPercentage()*totalPoint/100)){
			System.err.println("Too many points spent on Lord. Can't add " +  name+ " ("+pointCostOfThis+ ")>(" +((lord+pointCostOfThis)-(os.getMaxLordsPercentage()*totalPoint/100))+")");
			return false;
		}
		
//		System.out.println((totalPoint - (combinedMinusCore+pointCostOfThis))<(os.getMinCorePercentage()*totalPoint/100));
//		System.out.println((totalPoint - (combinedMinusCore+pointCostOfThis))+ " " + (os.getMinCorePercentage()*totalPoint/100));
//		
		if(!type.equals("Core") && (totalPoint - (combinedMinusCore+pointCostOfThis))<(os.getMinCorePercentage()*totalPoint/100)){
			System.err.println("Too many points spent on things other than Core. Can't add " +  name+ " ("+((totalPoint - (combinedMinusCore+pointCostOfThis)))+ ")<(" +(os.getMinCorePercentage()*totalPoint/100)+ ")");
			return false;
		}
		
//		System.out.println((!type.equals(os.getLord())) && (!type.equals(os.getHero())));
//		System.out.println((!type.equals(os.getLord())) && (!type.equals(os.getHero())) && ((hero+lord)==0));
//		System.out.println((!type.equals(os.getLord())) && (!type.equals(os.getHero())) && ((hero+lord)==0) && ((core+ combinedMinusCore+pointCostOfThis + getLowestHeroLordCost())>(totalPoint)));
		
		float coreLimit = (os.getMinCorePercentage()*totalPoint/100);
		
		float corePointsForCalc = core;
		
		if(coreLimit>corePointsForCalc){
			corePointsForCalc = coreLimit;
		}
		
		if((!type.equals(os.getLord())) && (!type.equals(os.getHero())) && ((hero+lord)==0) && ((corePointsForCalc+ combinedMinusCore+pointCostOfThis + getLowestHeroLordCost())>(totalPoint))){
			System.err.println("Need to add a commander (lord or hero) " +  name + " (" + (corePointsForCalc + combinedMinusCore+pointCostOfThis + getLowestHeroLordCost()) + ")>(" + totalPoint+ ")");
			return false;
		}
		
		// TODO Lord/Hero check - done ish
		
		return true;
	}
	
	
	
	public String getDesiredFaction() {
		return desiredFaction;
	}

	public void setDesiredFaction(String desiredFaction) {
		this.desiredFaction = desiredFaction;
	}

	public float getDesiredPointLimit() {
		return desiredPointLimit;
	}

	public void setDesiredPointLimit(float desiredPointLimit) {
		this.desiredPointLimit = desiredPointLimit;
	}

	public List<UnitInstance> getDesiredUnits() {
		return desiredUnits;
	}

	public void setDesiredUnits(List<UnitInstance> desiredUnits) {
		this.desiredUnits = desiredUnits;
	}

	public ArmyInstance getQueryResult() {
		return queryResult;
	}

	public void setQueryResult(ArmyInstance queryResult) {
		this.queryResult = queryResult;
	}

	public HashMap<String, UnitInstance> getAvailableFactionUnitInstances() {
		return availableFactionUnitInstances;
	}

	public void setAvailableFactionUnitInstances(
			HashMap<String, UnitInstance> availableFactionUnitInstances) {
		this.availableFactionUnitInstances = availableFactionUnitInstances;
	}

	public Similarity getQuerySimilarity() {
		return querySimilarity;
	}

	public void setQuerySimilarity(Similarity querySimilarity) {
		this.querySimilarity = querySimilarity;
	}

	public float getMinimumCostOfUnit() {
		return minimumCostOfUnit;
	}

	public void setMinimumCostOfUnit(float minimumCostOfUnit) {
		this.minimumCostOfUnit = minimumCostOfUnit;
	}
	
	
	
	public float getLowestHeroLordCost() {
		return lowestHeroLordCost;
	}

	public void setLowestHeroLordCost(float lowestHeroLordCost) {
		this.lowestHeroLordCost = lowestHeroLordCost;
	}

	public static void main(String[] args) {
		
		File file = new File("ArmyModel\\ArmyModel.prj");
		OverviewSpecifics os = new OverviewSpecifics();
		
		Project j;
		try {
			j = new Project(file.getAbsolutePath());
			while(j.isImporting()){}
			RetriveArmies ra = new RetriveArmies(j, os);
			ra.getRetrivalInfo();
			ra.runQuery();
			
			
			boolean iterate = true;
			int iterations = 1000;
			List<Result> results = new ArrayList<>();
			HashMap<String, Integer> differentResultCount = new HashMap<>();
			HashMap<String, Result> differentResults = new HashMap<>();
			
			if(!iterate)
				iterations = 10;
			while(iterations>0){
				AdaptArmy aa = new AdaptArmy(j, ra.getQueryResult(), ra.getQuerySimilarity(), ra.getDesiredFaction(), ra.getDesiredPointLimit(), ra.getDesiredUnits(), ra.getAvailableFactionUnitInstances(), ra.getMinimumCostOfUnit(), os);
				aa.runAdaptation();
				Result r  = new Result();
				r.storeIntResults(aa.getCorePointsSpent(), aa.getRarePointsSpent(), aa.getSpecialPointsSpent(), aa.getHeroPointsSpent(), aa.getLordPointsSpent(), aa.getTotalPointsSpent(), aa.isAValidSolution());
				r.storeStringResults(aa.getCores(), aa.getRares(), aa.getSpecials(), aa.getHeroes(), aa.getLords());
				System.out.println(r.createUniqeID());
				results.add(r);
				iterations--;
			}
			
			int countInvalid = 0;
			for (Result result : results) {
				String id = result.createUniqeID();
				if(differentResultCount.containsKey(id)){
					differentResultCount.put(id, differentResultCount.get(id) +1);
				}
				else{
					differentResultCount.put(id, 1);
					differentResults.put(id, result);
				}
				if(!result.getValid())
					countInvalid +=1;
			}
			System.out.println(differentResultCount);
			System.out.println(differentResults);
			
			System.out.println(differentResultCount.size());
			System.out.println(differentResults.size());
			
			int best = 0;
			Result BestResult = null;
			for (String s : differentResultCount.keySet()) {
				if(differentResultCount.get(s)>best){
					best = differentResultCount.get(s);
					BestResult = differentResults.get(s);
				}
			}
			
			System.out.println("invalid armies " + countInvalid);
			
			System.out.println("Most frequent result");
			System.out.println(BestResult);
			
			System.out.println("query units");
			System.out.println(ra.getDesiredUnits());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
