package parserXML;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.Attribute;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

public class Characteristic {
	
	private String characteristicId;
	private String name;
	private String value;

	
	
	List<String> attributes;
	List<String> attributeValues;
	
	
	public Characteristic(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException {
		attributes = new ArrayList<String>();
		attributeValues = new ArrayList<String>();

		
		if(currentEvent.isStartElement()){
			StartElement elm = currentEvent.asStartElement();
//			System.out.println("  start -- characteristic");
			Iterator<Attribute> elementAttributes = elm.getAttributes();
			while(elementAttributes.hasNext()){
				Attribute elementAttribute = elementAttributes.next();
				
				if(elementAttribute.getName().getLocalPart().equals("characteristicId")){
					characteristicId = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("name")){
					name = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("value")){
					value = elementAttribute.getValue();
				}
				
				attributes.add(elementAttribute.getName().getLocalPart());
				attributeValues.add(elementAttribute.getValue());
			}
		}
		
//		System.out.println(attributes);
//		System.out.println(attributeValues);
//		System.out.println(name + " " + characteristicId + " " + value);
		
		
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			
			
			if(event.isEndElement()){
				EndElement endElm = event.asEndElement();
				if(endElm.getName().getLocalPart().equals("characteristic")){
//					System.out.println("  end -- characteristic");
					break;
				}
			}
		}
		
	}


	public String getCharacteristicId() {
		return characteristicId;
	}


	public void setCharacteristicId(String characteristicId) {
		this.characteristicId = characteristicId;
	}


	public String getName() {
		return name;
	}


	public void setName(String name) {
		this.name = name;
	}


	public String getValue() {
		return value;
	}


	public void setValue(String value) {
		this.value = value;
	}

}
