package parserXML;

import java.util.ArrayList;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

public class Characteristics {
	
	private List<Characteristic> characteristicsList;
	
	public Characteristics(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException {
		characteristicsList = new ArrayList<Characteristic>();
		
		if(currentEvent.asStartElement().getName().getLocalPart().equals("characteristics")){
//			System.out.println(" start -- characteristics");
		}
		
		Characteristic currentChacteristic;
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			currentChacteristic = null;
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				if(startElm.getName().getLocalPart().equals("characteristic")){
					currentChacteristic = new Characteristic(events,event);
					characteristicsList.add(currentChacteristic);
				}
			}
			if(event.isEndElement()){
				EndElement endElem = event.asEndElement();
				if(endElem.getName().getLocalPart().equals("characteristics")){
//					System.out.println(" end -- characteristics size: " + characteristicsList.size());
					break;
				}
			}
		}
	}

	public List<Characteristic> getCharacteristics() {	
		return characteristicsList;
	}

}
