package parserXML;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.Attribute;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

public class Condition {
	private String parentId;
	private String childId;
	private String field;
	private String type;
	private float value;
	
	
	List<String> attributes;
	List<String> attributeValues;
	
	
	
	public Condition(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException {
		attributes = new ArrayList<String>();
		attributeValues = new ArrayList<String>();
		
		if(currentEvent.isStartElement()){
			StartElement elm = currentEvent.asStartElement();
//			System.out.println("  start -- condition");
			Iterator<Attribute> elementAttributes = elm.getAttributes();
			while(elementAttributes.hasNext()){
				Attribute elementAttribute = elementAttributes.next();
				
				if(elementAttribute.getName().getLocalPart().equals("parentId")){
					parentId = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("childId")){
					childId = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("field")){
					field = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("type")){
					type = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("value")){
					value = Float.parseFloat(elementAttribute.getValue());
				}
		
				attributes.add(elementAttribute.getName().getLocalPart());
				attributeValues.add(elementAttribute.getValue());
			}
		}
		
//		System.out.println(attributes);
//		System.out.println(attributeValues);
//		System.out.println(field + " " + childId + " " + type + " " + value + " " + parentId);
		
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			
			if(event.isEndElement()){
				EndElement endElm = event.asEndElement();
				if(endElm.getName().getLocalPart().equals("condition")){
//					System.out.println("  end -- condition");
					break;
				}
			}
		}
	}



	public String getParentId() {
		return parentId;
	}



	public void setParentId(String parentId) {
		this.parentId = parentId;
	}



	public String getChildId() {
		return childId;
	}



	public void setChildId(String childId) {
		this.childId = childId;
	}



	public String getField() {
		return field;
	}



	public void setField(String field) {
		this.field = field;
	}



	public String getType() {
		return type;
	}



	public void setType(String type) {
		this.type = type;
	}



	public float getValue() {
		return value;
	}



	public void setValue(float value) {
		this.value = value;
	}

}
