package parserXML;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.Attribute;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

public class ConditionGroup {
	
	private String type;
	
	private List<Condition> conditions;
	private List<ConditionGroup> conditionGroups;
	
	List<String> attributes;
	List<String> attributeValues;
	
	List<String> fields;;
	
	public ConditionGroup(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException {
	
		attributes = new ArrayList<String>();
		attributeValues = new ArrayList<String>();
		fields = new ArrayList<String>();
		
		if(currentEvent.isStartElement()){
			StartElement elm = currentEvent.asStartElement();
//			System.out.println("  start -- conditionGroup");
			Iterator<Attribute> elementAttributes = elm.getAttributes();
			while(elementAttributes.hasNext()){
				Attribute elementAttribute = elementAttributes.next();
				
				if(elementAttribute.getName().getLocalPart().equals("type")){
					type = elementAttribute.getValue();
				}
		
				attributes.add(elementAttribute.getName().getLocalPart());
				attributeValues.add(elementAttribute.getValue());
			}
		}
		
//		System.out.println(attributes);
//		System.out.println(attributeValues);
//		System.out.println(type);
		
		Conditions tempConditions = null;
		ConditionGroups tempConditionGroups = null;
		
		
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				fields.add(startElm.getName().getLocalPart());
				if(startElm.getName().getLocalPart().equals("conditions")){
					tempConditions = new Conditions(events, event);
					conditions = tempConditions.getConditions();
				}
				else if(startElm.getName().getLocalPart().equals("conditionGroups")){
					tempConditionGroups = new ConditionGroups(events, event);
					conditionGroups = tempConditionGroups.getConditionGroups();
				}
			}
			
			if(event.isEndElement()){
				EndElement endElm = event.asEndElement();
				if(endElm.getName().getLocalPart().equals("conditionGroup")){
//					System.out.print(fields);
//					System.out.print("  end -- conditionGroup \n");
					break;
				}
			}
		}
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public List<Condition> getConditions() {
		return conditions;
	}

	public void setConditions(List<Condition> conditions) {
		this.conditions = conditions;
	}

	public List<ConditionGroup> getConditionGroups() {
		return conditionGroups;
	}

	public void setConditionGroups(List<ConditionGroup> conditionGroups) {
		this.conditionGroups = conditionGroups;
	}

}
