package parserXML;

import java.util.ArrayList;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

public class ConditionGroups {
	private List<ConditionGroup> conditionGroupList;
	

	public ConditionGroups(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException {
		conditionGroupList = new ArrayList<ConditionGroup>();
		
		if(currentEvent.asStartElement().getName().getLocalPart().equals("conditionGroups")){
//			System.out.println(" start -- conditionGroups");
		}
		ConditionGroup currentConditionGroup;
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			currentConditionGroup = null;
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				if(startElm.getName().getLocalPart().equals("conditionGroup")){
					currentConditionGroup = new ConditionGroup(events,event);
					conditionGroupList.add(currentConditionGroup);
				}
			}
			if(event.isEndElement()){
				EndElement endElem = event.asEndElement();
				if(endElem.getName().getLocalPart().equals("conditionGroups")){
//					System.out.println(" end -- conditionGroups size: " + conditionGroupList.size());
					break;
				}
			}
		}

	}

	public List<ConditionGroup> getConditionGroups() {
		return conditionGroupList;
	}

}
