package parserXML;

import java.util.ArrayList;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

public class Conditions {

	private List<Condition> conditionList;
	
	public Conditions(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException {
		conditionList = new ArrayList<Condition>();
		
		if(currentEvent.asStartElement().getName().getLocalPart().equals("conditions")){
//			System.out.println(" start -- conditions");
		}
		
		Condition currentCondition;
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			currentCondition = null;
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				if(startElm.getName().getLocalPart().equals("condition")){
					currentCondition = new Condition(events,event);
					conditionList.add(currentCondition);
				}
			}
			if(event.isEndElement()){
				EndElement endElem = event.asEndElement();
				if(endElem.getName().getLocalPart().equals("conditions")){
//					System.out.println(" end -- conditions size: " + conditionList.size());
					break;
				}
			}
		}
	}

	public List<Condition> getConditions() {
		return conditionList;
	}

}
