package parserXML;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.XMLEvent;

public class Description {

	private String description;
	
	public Description(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException {
		if(currentEvent.isStartElement()){
//			System.out.println("  start -- description");
		}
		
		description= "";
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			
			if(event.isCharacters()){
				
				description += event.asCharacters().getData();
			}
			
			if(event.isEndElement()){
				EndElement endElm = event.asEndElement();
				if(endElm.getName().getLocalPart().equals("description")){
					description = description.replace("\n", " ");
//					System.out.println(description);
//					System.out.println("  end -- description");
					break;
				}
			}
		}
	}

	public String getDescription() {
		return description;
	}
	
}
