package parserXML;

import java.util.ArrayList;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

/**
 * xml parser for the entryGroups, creating a list for the entrygroups within
 * @author harum
 *
 */

public class EntryGroups {
	private List<EntryGroup> entryGroupList;
	
	public EntryGroups(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException{
		entryGroupList = new ArrayList<EntryGroup>();
		
		
		if(currentEvent.asStartElement().getName().getLocalPart().equals("entryGroups")){
//			System.out.println(" start -- entrygroups");
		}
		
		EntryGroup currentEntryGroup;
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				if(startElm.getName().getLocalPart().equals("entryGroup")){
					currentEntryGroup = new EntryGroup(events,event);
					entryGroupList.add(currentEntryGroup);
				}
			}
			if(event.isEndElement()){
				EndElement endElem = event.asEndElement();
				if(endElem.getName().getLocalPart().equals("entryGroups")){
//					System.out.println(" end -- entryGroups size:" + entryGroupList.size());
					break;
				}
			}
		}
	}
	
	public List<EntryGroup> getEntryGroups(){
		return entryGroupList;
	}
}
