package parserXML;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.Attribute;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

public class Link {
	
	private String id;
	private String targetId;
	private String linkType;
	
	private List<Modifier> modifiers;
	

	List<String> attributes;
	List<String> attributeValues;
	
	List<String> fields;
	
	
	public Link(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException {
		attributes = new ArrayList<String>();
		attributeValues = new ArrayList<String>();
		fields = new ArrayList<String>();
		
		if(currentEvent.isStartElement()){
			StartElement elm = currentEvent.asStartElement();
//			System.out.println("  start -- link");
			Iterator<Attribute> elementAttributes = elm.getAttributes();
			while(elementAttributes.hasNext()){
				Attribute elementAttribute = elementAttributes.next();
				
				if(elementAttribute.getName().getLocalPart().equals("id")){
					id = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("targetId")){
					targetId = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("linkType")){
					linkType = elementAttribute.getValue();
				}
								
				
				attributes.add(elementAttribute.getName().getLocalPart());
				attributeValues.add(elementAttribute.getValue());
			}
		}
		
//		System.out.println(attributes);
//		System.out.println(attributeValues);
//		System.out.println(id + " " + targetId + " " + linkType);
		
		Modifiers tempModifiers = null;
		
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				fields.add(startElm.getName().getLocalPart());
				if(startElm.getName().getLocalPart().equals("modifiers")){
					tempModifiers = new Modifiers(events, event);
					modifiers = tempModifiers.getModifiers();
				}
			}
			
			if(event.isEndElement()){
				EndElement endElm = event.asEndElement();
				if(endElm.getName().getLocalPart().equals("link")){
//					System.out.print(fields);
//					System.out.print("  end -- link \n");
					break;
				}
			}
		}
		
	}


	public String getId() {
		return id;
	}


	public void setId(String id) {
		this.id = id;
	}


	public String getTargetId() {
		return targetId;
	}


	public void setTargetId(String targetId) {
		this.targetId = targetId;
	}


	public String getLinkType() {
		return linkType;
	}


	public void setLinkType(String linkType) {
		this.linkType = linkType;
	}


	public List<Modifier> getModifiers() {
		return modifiers;
	}


	public void setModifiers(List<Modifier> modifiers) {
		this.modifiers = modifiers;
	}


	public String toString(String indent) {
		// TODO Auto-generated method stub
		StringBuffer buf = new StringBuffer();
		buf.append(indent + "l "+  linkType);
		return buf.toString();
	}

}
