package parserXML;

import java.util.ArrayList;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

/**
 * xml parser for the links. creates a list of links similar to the structure in the xml.
 * @author harum
 *
 */

public class Links {

	private List<Link> linkList;
	

	public Links(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException{

		linkList = new ArrayList<Link>();
		
		if(currentEvent.asStartElement().getName().getLocalPart().equals("links")){
//			System.out.println(" start -- links");
		}
		
		Link currentLink;
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			currentLink = null;
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				if(startElm.getName().getLocalPart().equals("link")){
					currentLink = new Link(events,event);
					linkList.add(currentLink);
				}
			}
			if(event.isEndElement()){
				EndElement endElem = event.asEndElement();
				if(endElem.getName().getLocalPart().equals("links")){
//					System.out.println(" end -- links size: " +linkList.size());
					break;
				}
			}
		}
	}
	
	public List<Link> getLinks() {
		return linkList;
	}

}
