package parserXML;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.Attribute;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

public class Modifier {
	
	private String type;
	private String field;
	private float value;
	private boolean repeat;
	private int numRepeats;
	private String incrementParentId;
	private String incrementChildId;
	private String incrementField;
	private float incrementValue;
	
	private List<Condition> conditions;
	private List<ConditionGroup> conditionGroups;
	
	List<String> attributes;
	List<String> attributeValues;
	
	List<String> fields;
	
	
	
	public Modifier(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException {
		attributes = new ArrayList<String>();
		attributeValues = new ArrayList<String>();
		fields = new ArrayList<String>();
		
		if(currentEvent.isStartElement()){
			StartElement elm = currentEvent.asStartElement();
//			System.out.println("  start -- modifier");
			Iterator<Attribute> elementAttributes = elm.getAttributes();
			while(elementAttributes.hasNext()){
				Attribute elementAttribute = elementAttributes.next();
				
				if(elementAttribute.getName().getLocalPart().equals("type")){
					type = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("field")){
					field = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("value")){
					value = Float.parseFloat(elementAttribute.getValue());
				}
				else if(elementAttribute.getName().getLocalPart().equals("repeat")){
					repeat = Boolean.parseBoolean(elementAttribute.getValue());
				}
				else if(elementAttribute.getName().getLocalPart().equals("numRepeats")){
					numRepeats = Integer.parseInt(elementAttribute.getValue());
				}
				else if(elementAttribute.getName().getLocalPart().equals("incrementParentId")){
					incrementParentId = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("incrementChildId")){
					incrementChildId = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("incrementField")){
					incrementField = elementAttribute.getValue();
				}
				else if(elementAttribute.getName().getLocalPart().equals("incrementValue")){
					incrementValue = Float.parseFloat(elementAttribute.getValue());
				}
				
				
				
				attributes.add(elementAttribute.getName().getLocalPart());
				attributeValues.add(elementAttribute.getValue());
			}
		}
		
//		System.out.println(attributes);
//		System.out.println(attributeValues);
//		System.out.println(field + " "  + numRepeats + " " +  incrementChildId + " " +  incrementField +" " + repeat + " " + incrementParentId + " " +incrementValue  + " " + type + " " + value);
		
		Conditions tempConditions = null;
		ConditionGroups tempConditionGroups =null;
		
		
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				fields.add(startElm.getName().getLocalPart());
				if(startElm.getName().getLocalPart().equals("conditions")){
					tempConditions = new Conditions(events, event);
					conditions = tempConditions.getConditions();
				}
				else if(startElm.getName().getLocalPart().equals("conditionGroups")){
					tempConditionGroups = new ConditionGroups(events, event);
					conditionGroups = tempConditionGroups.getConditionGroups();
				}
				
			}
			
			if(event.isEndElement()){
				EndElement endElm = event.asEndElement();
				if(endElm.getName().getLocalPart().equals("modifier")){
//					System.out.print(fields);
//					System.out.print("  end -- modifier \n");
					break;
				}
			}
		}
	}



	public String getType() {
		return type;
	}



	public void setType(String type) {
		this.type = type;
	}



	public String getField() {
		return field;
	}



	public void setField(String field) {
		this.field = field;
	}



	public float getValue() {
		return value;
	}



	public void setValue(float value) {
		this.value = value;
	}



	public boolean isRepeat() {
		return repeat;
	}



	public void setRepeat(boolean repeat) {
		this.repeat = repeat;
	}



	public int getNumRepeats() {
		return numRepeats;
	}



	public void setNumRepeats(int numRepeats) {
		this.numRepeats = numRepeats;
	}



	public String getIncrementParentId() {
		return incrementParentId;
	}



	public void setIncrementParentId(String incrementParentId) {
		this.incrementParentId = incrementParentId;
	}



	public String getIncrementChildId() {
		return incrementChildId;
	}



	public void setIncrementChildId(String incrementChildId) {
		this.incrementChildId = incrementChildId;
	}



	public String getIncrementField() {
		return incrementField;
	}



	public void setIncrementField(String incrementField) {
		this.incrementField = incrementField;
	}



	public float getIncrementValue() {
		return incrementValue;
	}



	public void setIncrementValue(float incrementValue) {
		this.incrementValue = incrementValue;
	}



	public List<Condition> getConditions() {
		return conditions;
	}



	public void setConditions(List<Condition> conditions) {
		this.conditions = conditions;
	}



	public List<ConditionGroup> getConditionGroups() {
		return conditionGroups;
	}



	public void setConditionGroups(List<ConditionGroup> conditionGroups) {
		this.conditionGroups = conditionGroups;
	}



	public String toString(String indent) {
		// TODO Auto-generated method stub
		String indenter = indent + "m ";
		StringBuffer buf = new StringBuffer();
		buf.append(indenter + type);
		return buf.toString();
	}
}
