package parserXML;

import java.util.ArrayList;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;


public class Modifiers {
	
	private List<Modifier> modifierList;
	
	public Modifiers(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException{
		modifierList = new ArrayList<Modifier>();
		
		if(currentEvent.asStartElement().getName().getLocalPart().equals("modifiers")){
//			System.out.println(" start -- modifiers");
		}
		
		Modifier currentModifier;
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			currentModifier = null;
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				if(startElm.getName().getLocalPart().equals("modifier")){
					currentModifier = new Modifier(events,event);
					modifierList.add(currentModifier);
				}
			}
			if(event.isEndElement()){
				EndElement endElem = event.asEndElement();
				if(endElem.getName().getLocalPart().equals("modifiers")){
//					System.out.println(" end -- modifiers size: " + modifierList.size());
					break;
				}
			}
		}
	}
	
	public List<Modifier> getModifiers(){
		return modifierList;
	}
}
