package parserXML;

/**
 * A collection of all the identities found in the "master" warhammer xml. Hard coded for ease of access (and making a parser for this file is overkill).
 * @author harum
 *
 */

public class OverviewSpecifics {
	
	/**
	 * Unit 
	 */
	
	private String lords = "Lords";
	private String lord = "Lord";
	private String lordsId = "4c6f72647323232344415441232323";
	private float maxLordsPercentage = 50.0f; //amendment to book 25% is new 50%
	private float minLordsPercentage = 0.0f;
	
	private String heroes = "Heroes";
	private String hero = "Hero";
	private String heroesId = "4865726f657323232344415441232323";
	private float maxHeroesPercentage = 50.0f; //amendment to book 25% is new 50%
	private float minHeroesPercentage = 0.0f;
	
	private String core = "Core";
	private String coresId = "436f726523232344415441232323";
	private float maxCorePercentage = 100.0f;
	private float minCorePercentage = 25.0f;
	
	private String special = "Special";
	private String specialId = "5370656369616c23232344415441232323";
	private float maxSpecialPercentage = 50.0f;
	private float minSpecialPercentage = 0.0f;
	
	private String rare = "Rare";
	private String rareId = "5261726523232344415441232323";
	private float maxRarePercentage = 25.0f;
	private float minRarePercentage = 0.0f;
	
	/**
	 * Profile
	 */
	
	private String model = "Model";
	private String modelId = "4d6f64656c23232344415441232323";
	
		/**
		 * Characteristics
		 */
	
		private String movement = "M";
		private String movementLong = "Movement";
		private String movementId = "4d23232344415441232323";
		
		private String weaponSkill = "WS";
		private String weaponSkillLong = "Weapon Skill";
		private String weaponSkillId = "575323232344415441232323";
		
		private String ballisticSkill = "BS";
		private String ballisticSkillLong = "Ballistic Skill";
		private String bsId = "425323232344415441232323";
		
		private String strengthUnit = "S";
		private String strengthUnitLong = "Strength";
		private String strengthUnitId = "5323232344415441232323";
		
		private String toughness = "T";
		private String toughnessLong = "Toughness";
		private String toughnessId = "5423232344415441232323";
		
		private String wounds = "W";
		private String woundsLong ="Wounds";
		private String woundsId = "5723232344415441232323";
		
		private String initiative = "I";
		private String initiativeLong = "Initiative";
		private String initiativeId = "4923232344415441232323";
		
		private String attacks = "A";
		private String attacksLong = "Attacks";
		private String attacksId = "4123232344415441232323";
		
		private String leadership = "LD";
		private String leadershipLong = "Leadership";
		private String leadershipId = "4c4423232344415441232323";
		
		private String armorSave = "ArmorSave";
		private String armorSaveId = "41726d6f75725361766523232344415441232323";
		
		private String wardSave = "WardSave";
		private String wardSaveId = "576172645361766523232344415441232323";
		
		private String magicResist = "MR";
		private String magicResistLong = "Magic Resist";
		private String magicResistId = "4d5223232344415441232323";
		
		private String typeUnit = "Type";
		private String typeUnitId = "5479706523232344415441232323";
	
		
		
	private String weapon = "Weapon";
	private String weaponId = "576561706f6e23232344415441232323";
	
	
		private String range = "Range";
		private String rangeId = "52616e676523232344415441232323";
		
		private String strengthWeapon = "Strength";
		private String strengthWeaponId = "537472656e67746823232344415441232323";
		
		private String specialRules = "SpecialRules";
		private String specialRulesId = "5370656369616c2052756c657323232344415441232323";
		
		
		
	private String armor = "Armor";
	private String armorId = "41726d6f757223232344415441232323";
	
		private String savingThrowModifier = "SavingThrowModifier";
		private String savingThrowModifierId = "536176696e67205468726f77206d6f64696669657223232344415441232323";
		
		//Special rules
		
	
	private String talisman = "Talisman";
	private String talismanId = "54616c69736d616e23232344415441232323";
	
		private String protection = "Protection";
		private String protectionId = "50726f74656374696f6e23232344415441232323";
		
	
	
	private String arcaneEnchantedItem = "Arcane and Enchanted Item";
	private String arcaneEnchantedItemId = "417263616e6520616e6420456e6368616e746564204974656d23232344415441232323";
	
		private String magicProperty = "Magic Property";
		private String magicPropertyId = "4d616769632050726f706572747923232344415441232323";
	
		
	
	private String magicStandard = "Magic Standard";
	private String magicStandardId = "4d61676963205374616e6461726423232344415441232323";
	
		private String magicEmination = "Magic Emination";
		private String magicEminationId = "4d61676963616c20456d696e6174696f6e23232344415441232323";
	
	
		
		
		
	private String infantry = "Infantry";
	private String cavalry = "Cavalry";
	private String chariot = "Chariot";
	private String monster = "Monster";
	private String monsterousCavalry = "Monsterous Cavalry";
	private String monsterousInfantry = "Monsterous Infantry";
	private String swarm = "Swarm";
	private String unspecified = "Unspecified";
	private String warBeast = "War Beast";
	private String warMachine = "Warmachine";
	
	
	private String beastmen = "Beastmen";
	private String beastmenCB = "BeastmenUnits";
	
	private String bretonnia = "Bretonnia";
	private String bretonniaCB = "BretonniaUnits";
	
	private String daemonsofchaos = "Daemons of Chaos";
	private String daemonsofchaosCB = "DaemonsofchaosUnits";
	
	private String darkelves = "Dark Elves";
	private String darkelvesCB = "DarkelvesUnits";
	
	private String dwarfs = "Dwarfs";
	private String dwarfCB = "DwarfUnits";
	
	private String highelves = "High Elves";
	private String highelvesCB = "HighelvesUnits";
	
	private String lizardmen = "Lizardmen";
	private String lizardmenCB = "LizardmenUnits";
	
	private String ogrekingdoms = "Ogre Kingdoms";
	private String ogrekingdomsCB = "OgrekingdomsUnits";
	
	private String orcsandgoblins = "Orcs and Goblins";
	private String orcsandgoblinsCB = "OrcsandgoblinsUnits";
	
	private String skaven = "Skaven";
	private String skavenCB = "SkavenUnits";
	
	private String tombkings = "Tomb Kings";
	private String tombkingsCB = "TombkingsUnits";
	
	private String empire = "The Empire";
	private String empireCB = "EmpireUnits";
	
	private String vampirecounts = "Vampire Counts";
	private String vampirecountsCB = "VampirecountsUnits";
	
	private String warriorsofchaos = "Warriors of Chaos";
	private String warriorsofchaosCB = "WarriorsofchaosUnits";
	
	private String woodelves = "Wood Elves";
	private String woodelvesCB = "WoodelvesUnits";
	
	
	
	
	//update whenever new factions are added. TODO
	private String[] availableFactions = {dwarfs,highelves}; 
	
	
			
			
	public String getLords() {
		return lords;
	}
	public void setLords(String lords) {
		this.lords = lords;
	}
	public String getLordsId() {
		return lordsId;
	}
	public void setLordsId(String lordsId) {
		this.lordsId = lordsId;
	}
	public float getMaxLordsPercentage() {
		return maxLordsPercentage;
	}
	public void setMaxLordsPercentage(float maxLordsPercentage) {
		this.maxLordsPercentage = maxLordsPercentage;
	}
	public float getMinLordsPercentage() {
		return minLordsPercentage;
	}
	public void setMinLordsPercentage(float minLordsPercentage) {
		this.minLordsPercentage = minLordsPercentage;
	}
	public String getHeroes() {
		return heroes;
	}
	public void setHeroes(String heroes) {
		this.heroes = heroes;
	}
	public String getHeroesId() {
		return heroesId;
	}
	public void setHeroesId(String heroesId) {
		this.heroesId = heroesId;
	}
	public float getMaxHeroesPercentage() {
		return maxHeroesPercentage;
	}
	public void setMaxHeroesPercentage(float maxHeroesPercentage) {
		this.maxHeroesPercentage = maxHeroesPercentage;
	}
	public float getMinHeroesPercentage() {
		return minHeroesPercentage;
	}
	public void setMinHeroesPercentage(float minHeroesPercentage) {
		this.minHeroesPercentage = minHeroesPercentage;
	}
	public String getCore() {
		return core;
	}
	public void setCore(String core) {
		this.core = core;
	}
	public String getCoresId() {
		return coresId;
	}
	public void setCoresId(String coresId) {
		this.coresId = coresId;
	}
	public float getMaxCorePercentage() {
		return maxCorePercentage;
	}
	public void setMaxCorePercentage(float maxCorePercentage) {
		this.maxCorePercentage = maxCorePercentage;
	}
	public float getMinCorePercentage() {
		return minCorePercentage;
	}
	public void setMinCorePercentage(float minCorePercentage) {
		this.minCorePercentage = minCorePercentage;
	}
	public String getSpecial() {
		return special;
	}
	public void setSpecial(String special) {
		this.special = special;
	}
	public String getSpecialId() {
		return specialId;
	}
	public void setSpecialId(String specialId) {
		this.specialId = specialId;
	}
	public float getMaxSpecialPercentage() {
		return maxSpecialPercentage;
	}
	public void setMaxSpecialPercentage(float maxSpecialPercentage) {
		this.maxSpecialPercentage = maxSpecialPercentage;
	}
	public float getMinSpecialPercentage() {
		return minSpecialPercentage;
	}
	public void setMinSpecialPercentage(float minSpecialPercentage) {
		this.minSpecialPercentage = minSpecialPercentage;
	}
	public String getRare() {
		return rare;
	}
	public void setRare(String rare) {
		this.rare = rare;
	}
	public String getRareId() {
		return rareId;
	}
	public void setRareId(String rareId) {
		this.rareId = rareId;
	}
	public float getMaxRarePercentage() {
		return maxRarePercentage;
	}
	public void setMaxRarePercentage(float maxRarePercentage) {
		this.maxRarePercentage = maxRarePercentage;
	}
	public float getMinRarePercentage() {
		return minRarePercentage;
	}
	public void setMinRarePercentage(float minRarePercentage) {
		this.minRarePercentage = minRarePercentage;
	}
	public String getModel() {
		return model;
	}
	public void setModel(String model) {
		this.model = model;
	}
	public String getModelId() {
		return modelId;
	}
	public void setModelId(String modelId) {
		this.modelId = modelId;
	}
	public String getMovement() {
		return movement;
	}
	public void setMovement(String movement) {
		this.movement = movement;
	}
	public String getMovementLong() {
		return movementLong;
	}
	public void setMovementLong(String movementLong) {
		this.movementLong = movementLong;
	}
	public String getMovementId() {
		return movementId;
	}
	public void setMovementId(String movementId) {
		this.movementId = movementId;
	}
	public String getWeaponSkill() {
		return weaponSkill;
	}
	public void setWeaponSkill(String weaponSkill) {
		this.weaponSkill = weaponSkill;
	}
	public String getWeaponSkillLong() {
		return weaponSkillLong;
	}
	public void setWeaponSkillLong(String weaponSkillLong) {
		this.weaponSkillLong = weaponSkillLong;
	}
	public String getWeaponSkillId() {
		return weaponSkillId;
	}
	public void setWeaponSkillId(String weaponSkillId) {
		this.weaponSkillId = weaponSkillId;
	}
	public String getBallisticSkill() {
		return ballisticSkill;
	}
	public void setBallisticSkill(String ballisticSkill) {
		this.ballisticSkill = ballisticSkill;
	}
	public String getBallisticSkillLong() {
		return ballisticSkillLong;
	}
	public void setBallisticSkillLong(String ballisticSkillLong) {
		this.ballisticSkillLong = ballisticSkillLong;
	}
	public String getBsId() {
		return bsId;
	}
	public void setBsId(String bsId) {
		this.bsId = bsId;
	}
	public String getStrengthUnit() {
		return strengthUnit;
	}
	public void setStrengthUnit(String strengthUnit) {
		this.strengthUnit = strengthUnit;
	}
	public String getStrengthUnitLong() {
		return strengthUnitLong;
	}
	public void setStrengthUnitLong(String strengthUnitLong) {
		this.strengthUnitLong = strengthUnitLong;
	}
	public String getStrengthUnitId() {
		return strengthUnitId;
	}
	public void setStrengthUnitId(String strengthUnitId) {
		this.strengthUnitId = strengthUnitId;
	}
	public String getToughness() {
		return toughness;
	}
	public void setToughness(String toughness) {
		this.toughness = toughness;
	}
	public String getToughnessLong() {
		return toughnessLong;
	}
	public void setToughnessLong(String toughnessLong) {
		this.toughnessLong = toughnessLong;
	}
	public String getToughnessId() {
		return toughnessId;
	}
	public void setToughnessId(String toughnessId) {
		this.toughnessId = toughnessId;
	}
	public String getWounds() {
		return wounds;
	}
	public void setWounds(String wounds) {
		this.wounds = wounds;
	}
	public String getWoundsLong() {
		return woundsLong;
	}
	public void setWoundsLong(String woundsLong) {
		this.woundsLong = woundsLong;
	}
	public String getWoundsId() {
		return woundsId;
	}
	public void setWoundsId(String woundsId) {
		this.woundsId = woundsId;
	}
	public String getInitiative() {
		return initiative;
	}
	public void setInitiative(String initiative) {
		this.initiative = initiative;
	}
	public String getInitiativeLong() {
		return initiativeLong;
	}
	public void setInitiativeLong(String initiativeLong) {
		this.initiativeLong = initiativeLong;
	}
	public String getInitiativeId() {
		return initiativeId;
	}
	public void setInitiativeId(String initiativeId) {
		this.initiativeId = initiativeId;
	}
	public String getAttacks() {
		return attacks;
	}
	public void setAttacks(String attacks) {
		this.attacks = attacks;
	}
	public String getAttacksLong() {
		return attacksLong;
	}
	public void setAttacksLong(String attacksLong) {
		this.attacksLong = attacksLong;
	}
	public String getAttacksId() {
		return attacksId;
	}
	public void setAttacksId(String attacksId) {
		this.attacksId = attacksId;
	}
	public String getLeadership() {
		return leadership;
	}
	public void setLeadership(String leadership) {
		this.leadership = leadership;
	}
	public String getLeadershipLong() {
		return leadershipLong;
	}
	public void setLeadershipLong(String leadershipLong) {
		this.leadershipLong = leadershipLong;
	}
	public String getLeadershipId() {
		return leadershipId;
	}
	public void setLeadershipId(String leadershipId) {
		this.leadershipId = leadershipId;
	}
	public String getArmorSave() {
		return armorSave;
	}
	public void setArmorSave(String armorSave) {
		this.armorSave = armorSave;
	}
	public String getArmorSaveId() {
		return armorSaveId;
	}
	public void setArmorSaveId(String armorSaveId) {
		this.armorSaveId = armorSaveId;
	}
	public String getWardSave() {
		return wardSave;
	}
	public void setWardSave(String wardSave) {
		this.wardSave = wardSave;
	}
	public String getWardSaveId() {
		return wardSaveId;
	}
	public void setWardSaveId(String wardSaveId) {
		this.wardSaveId = wardSaveId;
	}
	public String getMagicResist() {
		return magicResist;
	}
	public void setMagicResist(String magicResist) {
		this.magicResist = magicResist;
	}
	public String getMagicResistLong() {
		return magicResistLong;
	}
	public void setMagicResistLong(String magicResistLong) {
		this.magicResistLong = magicResistLong;
	}
	public String getMagicResistId() {
		return magicResistId;
	}
	public void setMagicResistId(String magicResistId) {
		this.magicResistId = magicResistId;
	}
	public String getTypeUnit() {
		return typeUnit;
	}
	public void setTypeUnit(String typeUnit) {
		this.typeUnit = typeUnit;
	}
	public String getTypeUnitId() {
		return typeUnitId;
	}
	public void setTypeUnitId(String typeUnitId) {
		this.typeUnitId = typeUnitId;
	}
	public String getWeapon() {
		return weapon;
	}
	public void setWeapon(String weapon) {
		this.weapon = weapon;
	}
	public String getWeaponId() {
		return weaponId;
	}
	public void setWeaponId(String weaponId) {
		this.weaponId = weaponId;
	}
	public String getRange() {
		return range;
	}
	public void setRange(String range) {
		this.range = range;
	}
	public String getRangeId() {
		return rangeId;
	}
	public void setRangeId(String rangeId) {
		this.rangeId = rangeId;
	}
	public String getStrengthWeapon() {
		return strengthWeapon;
	}
	public void setStrengthWeapon(String strengthWeapon) {
		this.strengthWeapon = strengthWeapon;
	}
	public String getStrengthWeaponId() {
		return strengthWeaponId;
	}
	public void setStrengthWeaponId(String strengthWeaponId) {
		this.strengthWeaponId = strengthWeaponId;
	}
	public String getSpecialRules() {
		return specialRules;
	}
	public void setSpecialRules(String specialRules) {
		this.specialRules = specialRules;
	}
	public String getSpecialRulesId() {
		return specialRulesId;
	}
	public void setSpecialRulesId(String specialRulesId) {
		this.specialRulesId = specialRulesId;
	}
	public String getArmor() {
		return armor;
	}
	public void setArmor(String armor) {
		this.armor = armor;
	}
	public String getArmorId() {
		return armorId;
	}
	public void setArmorId(String armorId) {
		this.armorId = armorId;
	}
	public String getSavingThrowModifier() {
		return savingThrowModifier;
	}
	public void setSavingThrowModifier(String savingThrowModifier) {
		this.savingThrowModifier = savingThrowModifier;
	}
	public String getSavingThrowModifierId() {
		return savingThrowModifierId;
	}
	public void setSavingThrowModifierId(String savingThrowModifierId) {
		this.savingThrowModifierId = savingThrowModifierId;
	}
	public String getTalisman() {
		return talisman;
	}
	public void setTalisman(String talisman) {
		this.talisman = talisman;
	}
	public String getTalismanId() {
		return talismanId;
	}
	public void setTalismanId(String talismanId) {
		this.talismanId = talismanId;
	}
	public String getProtection() {
		return protection;
	}
	public void setProtection(String protection) {
		this.protection = protection;
	}
	public String getProtectionId() {
		return protectionId;
	}
	public void setProtectionId(String protectionId) {
		this.protectionId = protectionId;
	}
	public String getArcaneEnchantedItem() {
		return arcaneEnchantedItem;
	}
	public void setArcaneEnchantedItem(String arcaneEnchantedItem) {
		this.arcaneEnchantedItem = arcaneEnchantedItem;
	}
	public String getArcaneEnchantedItemId() {
		return arcaneEnchantedItemId;
	}
	public void setArcaneEnchantedItemId(String arcaneEnchantedItemId) {
		this.arcaneEnchantedItemId = arcaneEnchantedItemId;
	}
	public String getMagicProperty() {
		return magicProperty;
	}
	public void setMagicProperty(String magicProperty) {
		this.magicProperty = magicProperty;
	}
	public String getMagicPropertyId() {
		return magicPropertyId;
	}
	public void setMagicPropertyId(String magicPropertyId) {
		this.magicPropertyId = magicPropertyId;
	}
	public String getMagicStandard() {
		return magicStandard;
	}
	public void setMagicStandard(String magicStandard) {
		this.magicStandard = magicStandard;
	}
	public String getMagicStandardId() {
		return magicStandardId;
	}
	public void setMagicStandardId(String magicStandardId) {
		this.magicStandardId = magicStandardId;
	}
	public String getMagicEmination() {
		return magicEmination;
	}
	public void setMagicEmination(String magicEmination) {
		this.magicEmination = magicEmination;
	}
	public String getMagicEminationId() {
		return magicEminationId;
	}
	public void setMagicEminationId(String magicEminationId) {
		this.magicEminationId = magicEminationId;
	}
	public String getLord() {
		return lord;
	}
	public void setLord(String lord) {
		this.lord = lord;
	}
	public String getHero() {
		return hero;
	}
	public void setHero(String hero) {
		this.hero = hero;
	}
	public String getInfantry() {
		return infantry;
	}
	public void setInfantry(String infantry) {
		this.infantry = infantry;
	}
	public String getCavalry() {
		return cavalry;
	}
	public void setCavalry(String cavalry) {
		this.cavalry = cavalry;
	}
	public String getChariot() {
		return chariot;
	}
	public void setChariot(String chariot) {
		this.chariot = chariot;
	}
	public String getMonster() {
		return monster;
	}
	public void setMonster(String monster) {
		this.monster = monster;
	}
	public String getMonsterousCavalry() {
		return monsterousCavalry;
	}
	public void setMonsterousCavalry(String monsterousCavalry) {
		this.monsterousCavalry = monsterousCavalry;
	}
	public String getMonsterousInfantry() {
		return monsterousInfantry;
	}
	public void setMonsterousInfantry(String monsterousInfantry) {
		this.monsterousInfantry = monsterousInfantry;
	}
	public String getSwarm() {
		return swarm;
	}
	public void setSwarm(String swarm) {
		this.swarm = swarm;
	}
	public String getUnspecified() {
		return unspecified;
	}
	public void setUnspecified(String unspecified) {
		this.unspecified = unspecified;
	}
	public String getWarBeast() {
		return warBeast;
	}
	public void setWarBeast(String warBeast) {
		this.warBeast = warBeast;
	}
	public String getWarMachine() {
		return warMachine;
	}
	public void setWarMachine(String warMachine) {
		this.warMachine = warMachine;
	}
	
	public boolean isArmyUnit(String id){
		return id.equals(getCoresId()) || id.equals(getSpecialId()) || id.equals(getRareId()) || id.equals(getHeroesId()) || id.equals(getLordsId());
	}
	public String getDwarfs() {
		return dwarfs;
	}
	public void setDwarfs(String dwarfs) {
		this.dwarfs = dwarfs;
	}
	public String getDwarfCB() {
		return dwarfCB;
	}
	public void setDwarfCB(String dwarfCB) {
		this.dwarfCB = dwarfCB;
	}
	public String getBretonnia() {
		return bretonnia;
	}
	public void setBretonnia(String bretonnia) {
		this.bretonnia = bretonnia;
	}
	public String getBretonniaCB() {
		return bretonniaCB;
	}
	public void setBretonniaCB(String bretonniaCB) {
		this.bretonniaCB = bretonniaCB;
	}
	public String getBeastmen() {
		return beastmen;
	}
	public void setBeastmen(String beastmen) {
		this.beastmen = beastmen;
	}
	public String getBeastmenCB() {
		return beastmenCB;
	}
	public void setBeastmenCB(String beastmenCB) {
		this.beastmenCB = beastmenCB;
	}
	public String getDaemonsofchaos() {
		return daemonsofchaos;
	}
	public void setDaemonsofchaos(String daemonsofchaos) {
		this.daemonsofchaos = daemonsofchaos;
	}
	public String getDaemonsofchaosCB() {
		return daemonsofchaosCB;
	}
	public void setDaemonsofchaosCB(String daemonsofchaosCB) {
		this.daemonsofchaosCB = daemonsofchaosCB;
	}
	public String getDarkelves() {
		return darkelves;
	}
	public void setDarkelves(String darkelves) {
		this.darkelves = darkelves;
	}
	public String getDarkelvesCB() {
		return darkelvesCB;
	}
	public void setDarkelvesCB(String darkelvesCB) {
		this.darkelvesCB = darkelvesCB;
	}
	public String getHighelves() {
		return highelves;
	}
	public void setHighelves(String highelves) {
		this.highelves = highelves;
	}
	public String getHighelvesCB() {
		return highelvesCB;
	}
	public void setHighelvesCB(String highelvesCB) {
		this.highelvesCB = highelvesCB;
	}
	public String getLizardmen() {
		return lizardmen;
	}
	public void setLizardmen(String lizardmen) {
		this.lizardmen = lizardmen;
	}
	public String getLizardmenCB() {
		return lizardmenCB;
	}
	public void setLizardmenCB(String lizardmenCB) {
		this.lizardmenCB = lizardmenCB;
	}
	public String getOgrekingdoms() {
		return ogrekingdoms;
	}
	public void setOgrekingdoms(String ogrekingdoms) {
		this.ogrekingdoms = ogrekingdoms;
	}
	public String getOgrekingdomsCB() {
		return ogrekingdomsCB;
	}
	public void setOgrekingdomsCB(String ogrekingdomsCB) {
		this.ogrekingdomsCB = ogrekingdomsCB;
	}
	public String getOrcsandgoblins() {
		return orcsandgoblins;
	}
	public void setOrcsandgoblins(String orcsandgoblins) {
		this.orcsandgoblins = orcsandgoblins;
	}
	public String getOrcsandgoblinsCB() {
		return orcsandgoblinsCB;
	}
	public void setOrcsandgoblinsCB(String orcsandgoblinsCB) {
		this.orcsandgoblinsCB = orcsandgoblinsCB;
	}
	public String getSkaven() {
		return skaven;
	}
	public void setSkaven(String skaven) {
		this.skaven = skaven;
	}
	public String getSkavenCB() {
		return skavenCB;
	}
	public void setSkavenCB(String skavenCB) {
		this.skavenCB = skavenCB;
	}
	public String getTombkings() {
		return tombkings;
	}
	public void setTombkings(String tombkings) {
		this.tombkings = tombkings;
	}
	public String getTombkingsCB() {
		return tombkingsCB;
	}
	public void setTombkingsCB(String tombkingsCB) {
		this.tombkingsCB = tombkingsCB;
	}
	public String getEmpire() {
		return empire;
	}
	public void setEmpire(String empire) {
		this.empire = empire;
	}
	public String getEmpireCB() {
		return empireCB;
	}
	public void setEmpireCB(String empireCB) {
		this.empireCB = empireCB;
	}
	public String getVampirecounts() {
		return vampirecounts;
	}
	public void setVampirecounts(String vampirecounts) {
		this.vampirecounts = vampirecounts;
	}
	public String getVampirecountsCB() {
		return vampirecountsCB;
	}
	public void setVampirecountsCB(String vampirecountsCB) {
		this.vampirecountsCB = vampirecountsCB;
	}
	public String getWarriorsofchaos() {
		return warriorsofchaos;
	}
	public void setWarriorsofchaos(String warriorsofchaos) {
		this.warriorsofchaos = warriorsofchaos;
	}
	public String getWarriorsofchaosCB() {
		return warriorsofchaosCB;
	}
	public void setWarriorsofchaosCB(String warriorsofchaosCB) {
		this.warriorsofchaosCB = warriorsofchaosCB;
	}
	public String getWoodelves() {
		return woodelves;
	}
	public void setWoodelves(String woodelves) {
		this.woodelves = woodelves;
	}
	public String getWoodelvesCB() {
		return woodelvesCB;
	}
	public void setWoodelvesCB(String woodelvesCB) {
		this.woodelvesCB = woodelvesCB;
	}
	
	public String getCorrectCB(String Faction){
		if(getBeastmen().equals(Faction)){
			return getBeastmenCB();
		}
		else if(getBretonnia().equals(Faction)){
			return getBretonniaCB();
		}
		else if(getDaemonsofchaos().equals(Faction)){
			return getDaemonsofchaosCB();
		}
		else if(getDarkelves().equals(Faction)){
			return getDarkelvesCB();
		}
		else if(getDwarfs().equals(Faction)){
			return getDwarfCB();
		}
		else if(getHighelves().equals(Faction)){
			return getHighelvesCB();
		}
		else if(getLizardmen().equals(Faction)){
			return getLizardmenCB();
		}
		else if(getOgrekingdoms().equals(Faction)){
			return getOgrekingdomsCB();
		}
		else if(getOrcsandgoblins().equals(Faction)){
			return getOrcsandgoblinsCB();
		}
		else if(getSkaven().equals(Faction)){
			return getSkavenCB();
		}
		else if(getTombkings().equals(Faction)){
			return getTombkingsCB();
		}
		else if(getEmpire().equals(Faction)){
			return getEmpireCB();
		}
		else if(getVampirecounts().equals(Faction)){
			return getVampirecountsCB();
		}
		else if(getWarriorsofchaos().equals(Faction)){
			return getWarriorsofchaosCB();
		}
		else if(getWoodelves().equals(Faction)){
			return getWoodelvesCB();
		}
		else
			System.err.println("not a faction");
		return null;
	}
	
	public String[] getAvailableFactions() {
		return availableFactions;
	}
	public void setAvailableFactions(String[] availableFactions) {
		this.availableFactions = availableFactions;
	}
}
