package parserXML;

import java.util.ArrayList;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

/**
 * xml parser for the profiles. creates a list of profiles for the listed profiles within the tag.
 * @author harum
 *
 */

public class Profiles {

	private List<Profile> profileList;

	public Profiles(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException {
		profileList = new ArrayList<Profile>();
		
		if(currentEvent.asStartElement().getName().getLocalPart().equals("profiles")){
//			System.out.println(" start -- profiles");
		}
		
		Profile currentProfile;
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			currentProfile = null;
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				if(startElm.getName().getLocalPart().equals("profile")){
					currentProfile = new Profile(events,event);
					profileList.add(currentProfile);
				}
			}
			if(event.isEndElement()){
				EndElement endElem = event.asEndElement();
				if(endElem.getName().getLocalPart().equals("profiles")){
//					System.out.println(" end -- profiles size: " +profileList.size());
					break;
				}
			}
		}
	}

	public List<Profile> getProfiles() {
		return profileList;
	}
}
