package parserXML;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


import java.util.Map;

import java.util.TreeMap;

//import javax.swing.JFileChooser;
//import javax.swing.JPanel;
import javax.xml.stream.FactoryConfigurationError;
import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.Attribute;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;



public class ReaderMain{
	
	private List<Catalogue> catalogues;
	
	private OverviewSpecifics os;
	
//	private Map<String,Profile> sharedProfiles;
//	private Map<String,Rule> sharedRules;
//	
//	private List<String> attackList;
//	
//	public void initMap(Catalogue cat){
//		sharedProfiles = new TreeMap<String,Profile>();
//		for (Profile p : cat.getSharedProfiles()) {
//			sharedProfiles.put(p.getId(), p);
//		}
//		sharedRules = new TreeMap<String,Rule>();
//		for (Rule r : cat.getSharedRules()) {
//			sharedRules.put(r.getId(), r);
//		}
//		
//		System.out.println("sharedProfiles " + sharedProfiles.size());
//		System.out.println("sharedRules " + sharedRules.size());
//		
//		attackList = new ArrayList<String>();
//	}
	
	public static void main(String[] args) throws FileNotFoundException,
	XMLStreamException, FactoryConfigurationError {
		// First create a new XMLInputFactory
		ReaderMain r = new ReaderMain();
		r.initiateReader();
		
		Catalogue cat = r.getCatalogues().get(4);
//		r.initMap(cat);
		cat.initMap();
		
		r.testLords(cat);
		r.testHeroes(cat);
		r.testCores(cat);
		r.testSpecial(cat);
		r.testRares(cat);
//		r.testAttacks();
	}
	
	public void initiateReader() throws FileNotFoundException, XMLStreamException{
		XMLInputFactory inputFactory = XMLInputFactory.newInstance();
		
		catalogues = new ArrayList<Catalogue>();
		
		//inputFactory.setProperty("javax.xml.stream.isCoalescing", True)

		// Setup a new eventReader
		
//		fc.showOpenDialog(parent)
		
		File folder = new File("RacesXML");
		
		for (final File fileEntry : folder.listFiles()) {
			System.out.println(fileEntry.getName());
			InputStream in = new FileInputStream(fileEntry); // Dwarfs - 8thBRB_8thAB.xml  TestMe2.xml TestMe3.xml
			XMLEventReader eventReader = inputFactory.createXMLEventReader(in);
			
			long time = System.nanoTime();
			
			Catalogue cat = null;
			while (eventReader.hasNext()) {
				XMLEvent event = eventReader.nextEvent();
				
				//reach the start of an item
				if (event.isStartElement()) {
					
					StartElement startElement = event.asStartElement();
					
					if(startElement.getName().getLocalPart().equals("catalogue")){
						cat = new Catalogue(eventReader,event);
					}
					else {
						System.out.println(" should not be here: " +startElement.getName().getLocalPart());
					}
				}
			}
//			System.out.println(cat.toString(""));
			System.out.println("spent time " + (((System.nanoTime()-time)/1000000)) + " ms");
			catalogues.add(cat);
		}
		System.out.println("cats: " + catalogues.size());
		System.out.println();
		
		os = new OverviewSpecifics();
	}
	
	public void testCores(Catalogue cat){
		
		System.out.println("cores");
		List<Entry> entries = cat.getEntries();
		for (Entry entry : entries) {
			if(entry.getCategoryId().equals(os.getCoresId())){
				System.out.println(entry.getName() + " " + entry.getPoints() + " " + entry.getType());
				testProfile(entry, "");
				testLinks(cat,entry,"");
				recCallEntries(cat, entry, "");
			}
		}
		System.out.println();
	}
	
	public void testRares(Catalogue cat){
		
		System.out.println("rares");
		List<Entry> entries = cat.getEntries();
		for (Entry entry : entries) {
			if(entry.getCategoryId().equals(os.getRareId())){
				System.out.println(entry.getName() + " " + entry.getPoints() + " " + entry.getType());
				testProfile(entry, "");
				recCallEntries(cat, entry, "");
			}
		}
		System.out.println();
	}
	
	public void testSpecial(Catalogue cat){
		
		System.out.println("specials");
		List<Entry> entries = cat.getEntries();
		for (Entry entry : entries) {
			if(entry.getCategoryId().equals(os.getSpecialId())){
				System.out.println(entry.getName() + " " + entry.getPoints()  + " " + entry.getType());
				testProfile(entry, "");
				recCallEntries(cat, entry, "");
			}
		}
		System.out.println();
	}
	
	public void testLords(Catalogue cat){
		System.out.println("lords");
		List<Entry> entries = cat.getEntries();
		for (Entry entry : entries) {
			if(entry.getCategoryId().equals(os.getLordsId())){
				System.out.println(entry.getName() + " " + entry.getPoints() + " " + entry.getType());
				testProfile(entry, "");
				testLinks(cat,entry,"");
				recCallEntries(cat, entry, "");
			}
		}
		System.out.println();
	}
	
	public void testHeroes(Catalogue cat){
		System.out.println("heroes");
		List<Entry> entries = cat.getEntries();
		for (Entry entry : entries) {
			if(entry.getCategoryId().equals(os.getHeroesId())){
				System.out.println(entry.getName() + " " + entry.getPoints() + " " + entry.getType());
				testProfile(entry, "");
				recCallEntries(cat, entry, "");
			}
		}
		System.out.println();
	}
	
	public void recCallEntries(Catalogue cat, Entry entry, String indent){
		String newIndent = indent + "  ";
		List<Entry> subEntries = entry.getEntries();
		for (Entry entry2 : subEntries) {			
			System.out.println(newIndent + entry2.getName() + " " + entry2.getPoints() + " " + entry2.getType());
			testProfile(entry2, newIndent);
			testLinks(cat,entry2,newIndent);
			recCallEntries(cat, entry2, newIndent);
		}
	}
	
	public void testProfile(Entry entry, String indent){
		List<Profile> profiles = entry.getProfiles();
		for (Profile profile : profiles) {
			List<Characteristic> characteristics = profile.getCharacteristics();
			if(profile.getProfileTypeId().equals(os.getModelId())){
				System.out.print(indent + os.getModel() + ": " + profile.getName()+ " ");
				for (Characteristic characteristic : characteristics) {
//					if(characteristic.getName().equals(os.getAttacks()))
//						attackList.add(characteristic.getValue());
					System.out.print(characteristic.getName() + " " + characteristic.getValue() +" ");
				}
				System.out.print("\n");
			}
			else if(profile.getProfileTypeId().equals(os.getWeaponId())){
				System.out.print(indent + os.getWeapon() + ": " + profile.getName() + " ");
				for (Characteristic characteristic : characteristics) {
					System.out.print(characteristic.getName() + " " + characteristic.getValue() +" ");
				}
				System.out.print("\n");
			}
			else if(profile.getProfileTypeId().equals(os.getArmorId())){
				System.out.print(indent + os.getArmor() + ": " + profile.getName() + " ");
				for (Characteristic characteristic : characteristics) {
					System.out.print(characteristic.getName() + " " + characteristic.getValue() +" ");
				}
				System.out.print("\n");
			}
			else if(profile.getProfileTypeId().equals(os.getArcaneEnchantedItemId())){
				System.out.print(indent + os.getArcaneEnchantedItem() + ": " + profile.getName()  + " ");
				for (Characteristic characteristic : characteristics) {
					System.out.print(characteristic.getName() + " " + characteristic.getValue() +" ");
				}
				System.out.print("\n");
			}
			else if(profile.getProfileTypeId().equals(os.getTalismanId())){
				System.out.print(indent + os.getTalisman() + ": " + profile.getName()  + " ");
				for (Characteristic characteristic : characteristics) {
					System.out.print(characteristic.getName() + " " + characteristic.getValue() +" ");
				}
				System.out.print("\n");
			}
			else if(profile.getProfileTypeId().equals(os.getMagicStandardId())){
				System.out.print(indent + os.getMagicStandard() + ": " + profile.getName() + " ");
				for (Characteristic characteristic : characteristics) {
					System.out.print(characteristic.getName() + " " + characteristic.getValue() +" ");
				}
				System.out.print("\n");
			}
		}
	}
	
	public void testProfile(Profile profile, String indent){
		List<Characteristic> characteristics = profile.getCharacteristics();
		if(profile.getProfileTypeId().equals(os.getModelId())){
			System.err.print(indent + os.getModel() + ": " + profile.getName()+ " ");
			for (Characteristic characteristic : characteristics) {
//				if(characteristic.getName().equals(os.getAttacks()))
//					attackList.add(characteristic.getValue());
				System.err.print(characteristic.getName() + " " + characteristic.getValue() +" ");
			}
			System.err.print("\n");
		}
		else if(profile.getProfileTypeId().equals(os.getWeaponId())){
			System.err.print(indent + os.getWeapon() + ": " + profile.getName() + " ");
			for (Characteristic characteristic : characteristics) {
				System.err.print(characteristic.getName() + " " + characteristic.getValue() +" ");
			}
			System.err.print("\n");
		}
		else if(profile.getProfileTypeId().equals(os.getArmorId())){
			System.err.print(indent + os.getArmor() + ": " + profile.getName() + " ");
			for (Characteristic characteristic : characteristics) {
				System.err.print(characteristic.getName() + " " + characteristic.getValue() +" ");
			}
			System.err.print("\n");
		}
		else if(profile.getProfileTypeId().equals(os.getArcaneEnchantedItemId())){
			System.err.print(indent + os.getArcaneEnchantedItem() + ": " + profile.getName()  + " ");
			for (Characteristic characteristic : characteristics) {
				System.err.print(characteristic.getName() + " " + characteristic.getValue() +" ");
			}
			System.err.print("\n");
		}
		else if(profile.getProfileTypeId().equals(os.getTalismanId())){
			System.err.print(indent + os.getTalisman() + ": " + profile.getName()  + " ");
			for (Characteristic characteristic : characteristics) {
				System.err.print(characteristic.getName() + " " + characteristic.getValue() +" ");
			}
			System.err.print("\n");
		}
		else if(profile.getProfileTypeId().equals(os.getMagicStandardId())){
			System.err.print(indent + os.getMagicStandard() + ": " + profile.getName() + " ");
			for (Characteristic characteristic : characteristics) {
				System.err.print(characteristic.getName() + " " + characteristic.getValue() +" ");
			}
			System.err.print("\n");
		}
	}
	
	public void testLinks(Catalogue cat, Entry entry , String indent){
		List<Link> links = entry.getLinks();
		
		for (Link link : links) {
			String target = link.getTargetId();
			String type = link.getLinkType();
			if(type.equals("profile")){
				System.err.println(indent +"p "+ cat.getSharedProfilesMap().get(target).getName());
				testProfile(cat.getSharedProfilesMap().get(target),indent);
			}
			else if(type.equals("rule")){
				System.err.println(indent +"r "+ cat.getSharedRulesMap().get(target).getName());
			}
		}
	}
	
//	public void testAttacks(){
//		for (String string : attackList) {
//			System.out.println(string);
//		}
//		System.out.println(attackList.size());
//	}
	
	
	public List<Catalogue> getCatalogues() {
		return catalogues;
	}

	public void setCatalogues(List<Catalogue> cataloguesInsert) {
		catalogues = cataloguesInsert;
	}
}
