package parserXML;

import java.util.ArrayList;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

/**
 * xml parser for the shared entries, creating a sharedentries list within.
 * @author harum
 *
 */

public class SharedEntries {
	
	private List<Entry> entryList;
	
	public SharedEntries(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException{
		entryList = new ArrayList<Entry>();
		
		if(currentEvent.asStartElement().getName().getLocalPart().equals("sharedEntries")){
//			System.out.println(" start -- sharedEntries");
		}
		Entry currentEntry;
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			currentEntry = null;
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				if(startElm.getName().getLocalPart().equals("entry")){
					currentEntry = new Entry(events,event);
					entryList.add(currentEntry);
				}
			}
			if(event.isEndElement()){
				EndElement endElem = event.asEndElement();
				if(endElem.getName().getLocalPart().equals("sharedEntries")){
//					System.out.println(" end -- sharedEntries size: " +entryList.size());
					break;
				}
			}
		}
	}
	
	public List<Entry> getEntries(){
		return entryList;
	}
}
