package parserXML;

import java.util.ArrayList;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

public class SharedProfiles {
	private List<Profile> profileList;

	public SharedProfiles(XMLEventReader events, XMLEvent currentEvent) throws XMLStreamException {
		profileList = new ArrayList<Profile>();
		
		if(currentEvent.asStartElement().getName().getLocalPart().equals("sharedProfiles")){
//			System.out.println(" start -- sharedProfiles");
		}
		
		Profile currentProfile;
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			currentProfile = null;
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				if(startElm.getName().getLocalPart().equals("profile")){
					currentProfile = new Profile(events,event);
					profileList.add(currentProfile);
				}
			}
			if(event.isEndElement()){
				EndElement endElem = event.asEndElement();
				if(endElem.getName().getLocalPart().equals("sharedProfiles")){
//					System.out.println(" end -- sharedProfiles size: " +profileList.size());
					break;
				}
			}
		}
	}

	public List<Profile> getProfiles() {
		return profileList;
	}
}
