package parserXML;

import java.util.ArrayList;
import java.util.List;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

public class SharedRules {
private List<Rule> ruleList;
	

	public SharedRules(XMLEventReader events, XMLEvent currentEvent)  throws XMLStreamException{
		ruleList = new ArrayList<Rule>();
		
		if(currentEvent.asStartElement().getName().getLocalPart().equals("sharedRules")){
//			System.out.println(" start -- sharedRules");
		}
			
		Rule currentRule;
		while(events.hasNext()){
			XMLEvent event = events.nextEvent();
			currentRule = null;
			
			if(event.isStartElement()){
				StartElement startElm = event.asStartElement();
				if(startElm.getName().getLocalPart().equals("rule")){
					currentRule = new Rule(events,event);
					ruleList.add(currentRule);
				}
			}
			if(event.isEndElement()){
				EndElement endElem = event.asEndElement();
				if(endElem.getName().getLocalPart().equals("sharedRules")){
//					System.out.println(" end -- sharedRules size: " + ruleList.size());
					break;
				}
			}
		}
	}

	public List<Rule> getRules() {
		return ruleList;
	}
}
